### DBProxy开发规范    

#### 1.代码中出现的数字等，尽量使用见名知义的宏定义   

- 下面的代码片段是不被推荐的： 
  
```
if (id == 0) {
 //todo sth.
} else {
 //todo sth.
}
```    

- 下面的代码片段是被推荐的：  
 
```
#define TK_COMMENT 0

if (id == TK_COMMENT) {
 //todo sth.
} else {
 //todo sth.
}
```   

#### 2.commit log书写规范

```
本次提交的描述信息。（issue #no）
```

例如：

```
git commit -m "bugfix: 修复 动态修改权重不生效。(issue #12)"
git commit -m "feature: 新增 标记tag，可进行从库流量配置功能。(issue #13)"
```

#### 3.日志输出规范
DBProxy使用以下五种级别日志输出：

```
debug/message/warning/critical/error
```    

五种级别的定义：

```
Debug: （调试时需要关心）
级别最低，正常运行的程序不应该输出。在编程人员调试程序、查找故障时候，用于变量的打印，查看。因此，debug预留给调试使用的，正常发布的版本中不应该出现debug级别的日志。
Message:(用户需要关心)
级别比Debug略高，用来对程序执行过程中，关键的正常行为对用户的通知，例如：通知用户，已经增加主库成功等。该日志是用户需要关心的，需要写的通俗易懂，尽量不要带有专业术语（例如哪个函数怎么怎么样，用户才不会关心，也不懂，使用用户能懂的语言沟通）。一般作为对用户的正确操作的一种反馈。
Warning:（运维人员需要关心）
级别比Mesage略高，警告。发生了一种不正常（与预期有偏差）的行为，但是此时不会影响系统正常运行，系统已经对此类错误具有容错，但是具有潜在风险。
Critical:（运维人员需要关注）
级别比Warning略高，错误。是一种不正常的未知行为，但是已经超出了目前已知的程序容错范围，因此不能确定是否会影响程序将来的正常运行。
Error:（运维人员需要处理）
级别最高，高危。发生了确定无法修复的错误，该错误必然会影响程序现在或是将来的运行，必须将程序停止。
```

**注意**

只要认为是错误，需要选择warning/critical/error其中之一。warning：异常但是确定可以恢复。critical：异常，谁知道影响会是怎样。error：异常，确定不能处理，并会产生严重影响。


