#ifndef _NETWORK_CON_ERRCODE_H_
#define _NETWORK_CON_ERRCODE_H_

#define MIN_CODE_NUM    1000
#define MAX_CODE_NUM    3194
#define DIFFERENCE      1000

#define ISVALID(code)   (code <= MAX_CODE_NUM && code >= MIN_CODE_NUM)
#define ERRMSG(code)    (ISVALID(code) ? errcode_map[code-DIFFERENCE].errmsg : "")
#define SQLSTATE(code)  (ISVALID(code) ? errcode_map[code-DIFFERENCE].sqlstate : "")

struct mysql_error_info {
    guint16 errcode;
    gchar   *sqlstate;
    gchar   *errmsg;
};

static struct mysql_error_info errcode_map[] = {
    {1000, "HY000", "hashchk"},
    {1001, "HY000", "isamchk"},
    {1002, "HY000", "NO"},
    {1003, "HY000", "YES"},
    {1004, "HY000", "Can't create file '' (errno:  - )"},
    {1005, "HY000", "Can't create table '' (errno: )"},
    {1006, "HY000", "Can't create database '' (errno: )"},
    {1007, "HY000", "Can't create database ''; database exists"},
    {1008, "HY000", "Can't drop database ''; database doesn't exist"},
    {1009, "HY000", "Error dropping database (can't delete '', errno: )"},
    {1010, "HY000", "Error dropping database (can't rmdir '', errno: )"},
    {1011, "HY000", "Error on delete of '' (errno:  - )"},
    {1012, "HY000", "Can't read record in system table"},
    {1013, "HY000", "Can't get status of '' (errno:  - )"},
    {1014, "HY000", "Can't get working directory (errno:  - )"},
    {1015, "HY000", "Can't lock file (errno:  - )"},
    {1016, "HY000", "Can't open file: '' (errno:  - )"},
    {1017, "HY000", "Can't find file: '' (errno:  - )"},
    {1018, "HY000", "Can't read dir of '' (errno:  - )"},
    {1019, "HY000", "Can't change dir to '' (errno:  - )"},
    {1020, "HY000", "Record has changed since last read in table ''"},
    {1021, "HY000", "Disk full (); waiting for someone to free some space... (errno:  - )"},
    {1022, "23000", "Can't write; duplicate key in table ''"},
    {1023, "HY000", "Error on close of '' (errno:  - )"},
    {1024, "HY000", "Error reading file '' (errno:  - )"},
    {1025, "HY000", "Error on rename of '' to '' (errno:  - )"},
    {1026, "HY000", "Error writing file '' (errno:  - )"},
    {1027, "HY000", "'' is locked against change"},
    {1028, "HY000", "Sort aborted"},
    {1029, "HY000", "View '' doesn't exist for ''"},
    {1030, "HY000", "Got error  from storage engine"},
    {1031, "HY000", "Table storage engine for '' doesn't have this option"},
    {1032, "HY000", "Can't find record in ''"},
    {1033, "HY000", "Incorrect information in file: ''"},
    {1034, "HY000", "Incorrect key file for table ''; try to repair it"},
    {1035, "HY000", "Old key file for table ''; repair it!"},
    {1036, "HY000", "Table '' is read only"},
    {1037, "HY001", "Out of memory; restart server and try again (needed  bytes)"},
    {1038, "HY001", "Out of sort memory, consider increasing server sort buffer size"},
    {1039, "HY000", "Unexpected EOF found when reading file '' (errno:  - )"},
    {1040, "08004", "Too many connections"},
    {1041, "HY000", "Out of memory; check if mysqld or some other process uses all available memory; if not, you may have to use 'ulimit' to allow mysqld to use more memory or you can add more swap space"},
    {1042, "08S01", "Can't get hostname for your address"},
    {1043, "08S01", "Bad handshake"},
    {1044, "42000", "Access denied for user ''@'' to database ''"},
    {1045, "28000", "Access denied for user ''@'' (using password: )"},
    {1046, "3D000", "No database selected"},
    {1047, "08S01", "Unknown command"},
    {1048, "23000", "Column '' cannot be null"},
    {1049, "42000", "Unknown database ''"},
    {1050, "42S01", "Table '' already exists"},
    {1051, "42S02", "Unknown table ''"},
    {1052, "23000", "Column '' in  is ambiguous"},
    {1053, "08S01", "Server shutdown in progress"},
    {1054, "42S22", "Unknown column '' in ''"},
    {1055, "42000", "'' isn't in GROUP BY"},
    {1056, "42000", "Can't group on ''"},
    {1057, "42000", "Statement has sum functions and columns in same statement"},
    {1058, "21S01", "Column count doesn't match value count"},
    {1059, "42000", "Identifier name '' is too long"},
    {1060, "42S21", "Duplicate column name ''"},
    {1061, "42000", "Duplicate key name ''"},
    {1062, "23000", "Duplicate entry '' for key "},
    {1063, "42000", "Incorrect column specifier for column ''"},
    {1064, "42000", " near '' at line "},
    {1065, "42000", "Query was empty"},
    {1066, "42000", "Not unique table/alias: ''"},
    {1067, "42000", "Invalid default value for ''"},
    {1068, "42000", "Multiple primary key defined"},
    {1069, "42000", "Too many keys specified; max  keys allowed"},
    {1070, "42000", "Too many key parts specified; max  parts allowed"},
    {1071, "42000", "Specified key was too long; max key length is  bytes"},
    {1072, "42000", "Key column '' doesn't exist in table"},
    {1073, "42000", "BLOB column '' can't be used in key specification with the used table type"},
    {1074, "42000", "Column length too big for column '' (max = ); use BLOB or TEXT instead"},
    {1075, "42000", "Incorrect table definition; there can be only one auto column and it must be defined as a key"},
    {1076, "HY000", ": ready for connections. Version: '' socket: '' port: "},
    {1077, "HY000", ": Normal shutdown"},
    {1078, "HY000", ": Got signal . Aborting!"},
    {1079, "HY000", ": Shutdown complete"},
    {1080, "08S01", ": Forcing close of thread  user: ''"},
    {1081, "08S01", "Can't create IP socket"},
    {1082, "42S12", "Table '' has no index like the one used in CREATE INDEX; recreate the table"},
    {1083, "42000", "Field separator argument is not what is expected; check the manual"},
    {1084, "42000", "You can't use fixed rowlength with BLOBs; please use 'fields terminated by'"},
    {1085, "HY000", "The file '' must be in the database directory or be readable by all"},
    {1086, "HY000", "File '' already exists"},
    {1087, "HY000", "Records:  Deleted:  Skipped:  Warnings: "},
    {1088, "HY000", "Records:  Duplicates: "},
    {1089, "HY000", "Incorrect prefix key; the used key part isn't a string, the used length is longer than the key part, or the storage engine doesn't support unique prefix keys"},
    {1090, "42000", "You can't delete all columns with ALTER TABLE; use DROP TABLE instead"},
    {1091, "42000", "Can't DROP ''; check that column/key exists"},
    {1092, "HY000", "Records:  Duplicates:  Warnings: "},
    {1093, "HY000", "You can't specify target table '' for update in FROM clause"},
    {1094, "HY000", "Unknown thread id: "},
    {1095, "HY000", "You are not owner of thread "},
    {1096, "HY000", "No tables used"},
    {1097, "HY000", "Too many strings for column  and SET"},
    {1098, "HY000", "Can't generate a unique log-filename .(1-999)"},
    {1099, "HY000", "Table '' was locked with a READ lock and can't be updated"},
    {1100, "HY000", "Table '' was not locked with LOCK TABLES"},
    {1101, "42000", "BLOB, TEXT, GEOMETRY or JSON column '' can't have a default value"},
    {1102, "42000", "Incorrect database name ''"},
    {1103, "42000", "Incorrect table name ''"},
    {1104, "42000", "The SELECT would examine more than MAX_JOIN_SIZE rows; check your WHERE and use SET SQL_BIG_SELECTS=1 or SET MAX_JOIN_SIZE=# if the SELECT is okay"},
    {1105, "HY000", "Unknown error"},
    {1106, "42000", "Unknown procedure ''"},
    {1107, "42000", "Incorrect parameter count to procedure ''"},
    {1108, "HY000", "Incorrect parameters to procedure ''"},
    {1109, "42S02", "Unknown table '' in "},
    {1110, "42000", "Column '' specified twice"},
    {1111, "HY000", "Invalid use of group function"},
    {1112, "42000", "Table '' uses an extension that doesn't exist in this MySQL version"},
    {1113, "42000", "A table must have at least 1 column"},
    {1114, "HY000", "The table '' is full"},
    {1115, "42000", "Unknown character set: ''"},
    {1116, "HY000", "Too many tables; MySQL can only use  tables in a join"},
    {1117, "HY000", "Too many columns"},
    {1118, "42000", "Row size too large. The maximum row size for the used table type, not counting BLOBs, is . This includes storage overhead, check the manual. You have to change some columns to TEXT or BLOBs"},
    {1119, "HY000", "Thread stack overrun: Used:  of a  stack. Use 'mysqld --thread_stack=#' to specify a bigger stack if needed"},
    {1120, "42000", "Cross dependency found in OUTER JOIN; examine your ON conditions"},
    {1121, "42000", "Table handler doesn't support NULL in given index. Please change column '' to be NOT NULL or use another handler"},
    {1122, "HY000", "Can't load function ''"},
    {1123, "HY000", "Can't initialize function ''; "},
    {1124, "HY000", "No paths allowed for shared library"},
    {1125, "HY000", "Function '' already exists"},
    {1126, "HY000", "Can't open shared library '' (errno:  )"},
    {1127, "HY000", "Can't find symbol '' in library"},
    {1128, "HY000", "Function '' is not defined"},
    {1129, "HY000", "Host '' is blocked because of many connection errors; unblock with 'mysqladmin flush-hosts'"},
    {1130, "HY000", "Host '' is not allowed to connect to this MySQL server"},
    {1131, "42000", "You are using MySQL as an anonymous user and anonymous users are not allowed to change passwords"},
    {1132, "42000", "You must have privileges to update tables in the mysql database to be able to change passwords for others"},
    {1133, "42000", "Can't find any matching row in the user table"},
    {1134, "HY000", "Rows matched:  Changed:  Warnings: "},
    {1135, "HY000", "Can't create a new thread (errno ); if you are not out of available memory, you can consult the manual for a possible OS-dependent bug"},
    {1136, "21S01", "Column count doesn't match value count at row "},
    {1137, "HY000", "Can't reopen table: ''"},
    {1138, "22004", "Invalid use of NULL value"},
    {1139, "42000", "Got error '' from regexp"},
    {1140, "42000", "Mixing of GROUP columns (MIN(),MAX(),COUNT(),...) with no GROUP columns is illegal if there is no GROUP BY clause"},
    {1141, "42000", "There is no such grant defined for user '' on host ''"},
    {1142, "42000", " command denied to user ''@'' for table ''"},
    {1143, "42000", " command denied to user ''@'' for column '' in table ''"},
    {1144, "42000", "Illegal GRANT/REVOKE command; please consult the manual to see which privileges can be used"},
    {1145, "42000", "The host or user argument to GRANT is too long"},
    {1146, "42S02", "Table '.' doesn't exist"},
    {1147, "42000", "There is no such grant defined for user '' on host '' on table ''"},
    {1148, "42000", "The used command is not allowed with this MySQL version"},
    {1149, "42000", "You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use"},
    {1150, "HY000", "Delayed insert thread couldn't get requested lock for table "},
    {1151, "HY000", "Too many delayed threads in use"},
    {1152, "08S01", "Aborted connection  to db: '' user: '' ()"},
    {1153, "08S01", "Got a packet bigger than 'max_allowed_packet' bytes"},
    {1154, "08S01", "Got a read error from the connection pipe"},
    {1155, "08S01", "Got an error from fcntl()"},
    {1156, "08S01", "Got packets out of order"},
    {1157, "08S01", "Couldn't uncompress communication packet"},
    {1158, "08S01", "Got an error reading communication packets"},
    {1159, "08S01", "Got timeout reading communication packets"},
    {1160, "08S01", "Got an error writing communication packets"},
    {1161, "08S01", "Got timeout writing communication packets"},
    {1162, "42000", "Result string is longer than 'max_allowed_packet' bytes"},
    {1163, "42000", "The used table type doesn't support BLOB/TEXT columns"},
    {1164, "42000", "The used table type doesn't support AUTO_INCREMENT columns"},
    {1165, "HY000", "INSERT DELAYED can't be used with table '' because it is locked with LOCK TABLES"},
    {1166, "42000", "Incorrect column name ''"},
    {1167, "42000", "The used storage engine can't index column ''"},
    {1168, "HY000", "Unable to open underlying table which is differently defined or of non-MyISAM type or doesn't exist"},
    {1169, "23000", "Can't write, because of unique constraint, to table ''"},
    {1170, "42000", "BLOB/TEXT column '' used in key specification without a key length"},
    {1171, "42000", "All parts of a PRIMARY KEY must be NOT NULL; if you need NULL in a key, use UNIQUE instead"},
    {1172, "42000", "Result consisted of more than one row"},
    {1173, "42000", "This table type requires a primary key"},
    {1174, "HY000", "This version of MySQL is not compiled with RAID support"},
    {1175, "HY000", "You are using safe update mode and you tried to update a table without a WHERE that uses a KEY column"},
    {1176, "42000", "Key '' doesn't exist in table ''"},
    {1177, "42000", "Can't open table"},
    {1178, "42000", "The storage engine for the table doesn't support "},
    {1179, "25000", "You are not allowed to execute this command in a transaction"},
    {1180, "HY000", "Got error  during COMMIT"},
    {1181, "HY000", "Got error  during ROLLBACK"},
    {1182, "HY000", "Got error  during FLUSH_LOGS"},
    {1183, "HY000", "Got error  during CHECKPOINT"},
    {1184, "08S01", "Aborted connection  to db: '' user: '' host: '' ()"},
    {1185, "HY000", "The storage engine for the table does not support binary table dump"},
    {1186, "HY000", "Binlog closed, cannot RESET MASTER"},
    {1187, "HY000", "Failed rebuilding the index of dumped table ''"},
    {1188, "HY000", "Error from master: ''"},
    {1189, "08S01", "Net error reading from master"},
    {1190, "08S01", "Net error writing to master"},
    {1191, "HY000", "Can't find FULLTEXT index matching the column list"},
    {1192, "HY000", "Can't execute the given command because you have active locked tables or an active transaction"},
    {1193, "HY000", "Unknown system variable ''"},
    {1194, "HY000", "Table '' is marked as crashed and should be repaired"},
    {1195, "HY000", "Table '' is marked as crashed and last (automatic?) repair failed"},
    {1196, "HY000", "Some non-transactional changed tables couldn't be rolled back"},
    {1197, "HY000", "Multi-statement transaction required more than 'max_binlog_cache_size' bytes of storage; increase this mysqld variable and try again"},
    {1198, "HY000", "This operation cannot be performed with a running slave; run STOP SLAVE first"},
    {1199, "HY000", "This operation requires a running slave; configure slave and do START SLAVE"},
    {1200, "HY000", "The server is not configured as slave; fix in config file or with CHANGE MASTER TO"},
    {1201, "HY000", "Could not initialize master info structure; more error messages can be found in the MySQL error log"},
    {1202, "HY000", "Could not create slave thread; check system resources"},
    {1203, "42000", "User  already has more than 'max_user_connections' active connections"},
    {1204, "HY000", "You may only use constant expressions with SET"},
    {1205, "HY000", "Lock wait timeout exceeded; try restarting transaction"},
    {1206, "HY000", "The total number of locks exceeds the lock table size"},
    {1207, "25000", "Update locks cannot be acquired during a READ UNCOMMITTED transaction"},
    {1208, "HY000", "DROP DATABASE not allowed while thread is holding global read lock"},
    {1209, "HY000", "CREATE DATABASE not allowed while thread is holding global read lock"},
    {1210, "HY000", "Incorrect arguments to "},
    {1211, "42000", "''@'' is not allowed to create new users"},
    {1212, "HY000", "Incorrect table definition; all MERGE tables must be in the same database"},
    {1213, "40001", "Deadlock found when trying to get lock; try restarting transaction"},
    {1214, "HY000", "The used table type doesn't support FULLTEXT indexes"},
    {1215, "HY000", "Cannot add foreign key constraint"},
    {1216, "23000", "Cannot add or update a child row: a foreign key constraint fails"},
    {1217, "23000", "Cannot delete or update a parent row: a foreign key constraint fails"},
    {1218, "08S01", "Error connecting to master: "},
    {1219, "HY000", "Error running query on master: "},
    {1220, "HY000", "Error when executing command : "},
    {1221, "HY000", "Incorrect usage of  and "},
    {1222, "21000", "The used SELECT statements have a different number of columns"},
    {1223, "HY000", "Can't execute the query because you have a conflicting read lock"},
    {1224, "HY000", "Mixing of transactional and non-transactional tables is disabled"},
    {1225, "HY000", "Option '' used twice in statement"},
    {1226, "42000", "User '' has exceeded the '' resource (current value: )"},
    {1227, "42000", "Access denied; you need (at least one of) the  privilege(s) for this operation"},
    {1228, "HY000", "Variable '' is a SESSION variable and can't be used with SET GLOBAL"},
    {1229, "HY000", "Variable '' is a GLOBAL variable and should be set with SET GLOBAL"},
    {1230, "42000", "Variable '' doesn't have a default value"},
    {1231, "42000", "Variable '' can't be set to the value of ''"},
    {1232, "42000", "Incorrect argument type to variable ''"},
    {1233, "HY000", "Variable '' can only be set, not read"},
    {1234, "42000", "Incorrect usage/placement of ''"},
    {1235, "42000", "This version of MySQL doesn't yet support ''"},
    {1236, "HY000", "Got fatal error  from master when reading data from binary log: ''"},
    {1237, "HY000", "Slave SQL thread ignored the query because of replicate-*-table rules"},
    {1238, "HY000", "Variable '' is a  variable"},
    {1239, "42000", "Incorrect foreign key definition for '': "},
    {1240, "HY000", "Key reference and table reference don't match"},
    {1241, "21000", "Operand should contain  column(s)"},
    {1242, "21000", "Subquery returns more than 1 row"},
    {1243, "HY000", "Unknown prepared statement handler () given to "},
    {1244, "HY000", "Help database is corrupt or does not exist"},
    {1245, "HY000", "Cyclic reference on subqueries"},
    {1246, "HY000", "Converting column '' from  to "},
    {1247, "42S22", "Reference '' not supported ()"},
    {1248, "42000", "Every derived table must have its own alias"},
    {1249, "01000", "Select  was reduced during optimization"},
    {1250, "42000", "Table '' from one of the SELECTs cannot be used in "},
    {1251, "08004", "Client does not support authentication protocol requested by server; consider upgrading MySQL client"},
    {1252, "42000", "All parts of a SPATIAL index must be NOT NULL"},
    {1253, "42000", "COLLATION '' is not valid for CHARACTER SET ''"},
    {1254, "HY000", "Slave is already running"},
    {1255, "HY000", "Slave already has been stopped"},
    {1256, "HY000", "Uncompressed data size too large; the maximum size is  (probably, length of uncompressed data was corrupted)"},
    {1257, "HY000", "ZLIB: Not enough memory"},
    {1258, "HY000", "ZLIB: Not enough room in the output buffer (probably, length of uncompressed data was corrupted)"},
    {1259, "HY000", "ZLIB: Input data corrupted"},
    {1260, "HY000", "Row  was cut by GROUP_CONCAT()"},
    {1261, "01000", "Row  doesn't contain data for all columns"},
    {1262, "01000", "Row  was truncated; it contained more data than there were input columns"},
    {1263, "22004", "Column set to default value; NULL supplied to NOT NULL column '' at row "},
    {1264, "22003", "Out of range value for column '' at row "},
    {1265, "01000", "Data truncated for column '' at row "},
    {1266, "HY000", "Using storage engine  for table ''"},
    {1267, "HY000", "Illegal mix of collations (,) and (,) for operation ''"},
    {1268, "HY000", "Cannot drop one or more of the requested users"},
    {1269, "HY000", "Can't revoke all privileges for one or more of the requested users"},
    {1270, "HY000", "Illegal mix of collations (,), (,), (,) for operation ''"},
    {1271, "HY000", "Illegal mix of collations for operation ''"},
    {1272, "HY000", "Variable '' is not a variable component (can't be used as XXXX.variable_name)"},
    {1273, "HY000", "Unknown collation: ''"},
    {1274, "HY000", "SSL parameters in CHANGE MASTER are ignored because this MySQL slave was compiled without SSL support; they can be used later if MySQL slave with SSL is started"},
    {1275, "HY000", "Server is running in --secure-auth mode, but ''@'' has a password in the old format; please change the password to the new format"},
    {1276, "HY000", "Field or reference '' of SELECT # was resolved in SELECT #"},
    {1277, "HY000", "Incorrect parameter or combination of parameters for START SLAVE UNTIL"},
    {1278, "HY000", "It is recommended to use --skip-slave-start when doing step-by-step replication with START SLAVE UNTIL; otherwise, you will get problems if you get an unexpected slave's mysqld restart"},
    {1279, "HY000", "SQL thread is not to be started so UNTIL options are ignored"},
    {1280, "42000", "Incorrect index name ''"},
    {1281, "42000", "Incorrect catalog name ''"},
    {1282, "HY000", "Query cache failed to set size ; new query cache size is "},
    {1283, "HY000", "Column '' cannot be part of FULLTEXT index"},
    {1284, "HY000", "Unknown key cache ''"},
    {1285, "HY000", "MySQL is started in --skip-name-resolve mode; you must restart it without this switch for this grant to work"},
    {1286, "42000", "Unknown storage engine ''"},
    {1287, "HY000", "'' is deprecated and will be removed in a future release. Please use  instead"},
    {1288, "HY000", "The target table  of the  is not updatable"},
    {1289, "HY000", "The '' feature is disabled; you need MySQL built with '' to have it working"},
    {1290, "HY000", "The MySQL server is running with the  option so it cannot execute this statement"},
    {1291, "HY000", "Column '' has duplicated value '' in "},
    {1292, "22007", "Truncated incorrect  value: ''"},
    {1293, "HY000", "Incorrect table definition; there can be only one TIMESTAMP column with CURRENT_TIMESTAMP in DEFAULT or ON UPDATE clause"},
    {1294, "HY000", "Invalid ON UPDATE clause for '' column"},
    {1295, "HY000", "This command is not supported in the prepared statement protocol yet"},
    {1296, "HY000", "Got error  '' from "},
    {1297, "HY000", "Got temporary error  '' from "},
    {1298, "HY000", "Unknown or incorrect time zone: ''"},
    {1299, "HY000", "Invalid TIMESTAMP value in column '' at row "},
    {1300, "HY000", "Invalid  character string: ''"},
    {1301, "HY000", "Result of () was larger than max_allowed_packet () - truncated"},
    {1302, "HY000", "Conflicting declarations: '' and ''"},
    {1303, "2F003", "Can't create a  from within another stored routine"},
    {1304, "42000", "  already exists"},
    {1305, "42000", "  does not exist"},
    {1306, "HY000", "Failed to DROP  "},
    {1307, "HY000", "Failed to CREATE  "},
    {1308, "42000", " with no matching label: "},
    {1309, "42000", "Redefining label "},
    {1310, "42000", "End-label  without match"},
    {1311, "01000", "Referring to uninitialized variable "},
    {1312, "0A000", "PROCEDURE  can't return a result set in the given context"},
    {1313, "42000", "RETURN is only allowed in a FUNCTION"},
    {1314, "0A000", " is not allowed in stored procedures"},
    {1315, "42000", "The update log is deprecated and replaced by the binary log; SET SQL_LOG_UPDATE has been ignored."},
    {1316, "42000", "The update log is deprecated and replaced by the binary log; SET SQL_LOG_UPDATE has been translated to SET SQL_LOG_BIN."},
    {1317, "70100", "Query execution was interrupted"},
    {1318, "42000", "Incorrect number of arguments for  ; expected , got "},
    {1319, "42000", "Undefined CONDITION: "},
    {1320, "42000", "No RETURN found in FUNCTION "},
    {1321, "2F005", "FUNCTION  ended without RETURN"},
    {1322, "42000", "Cursor statement must be a SELECT"},
    {1323, "42000", "Cursor SELECT must not have INTO"},
    {1324, "42000", "Undefined CURSOR: "},
    {1325, "24000", "Cursor is already open"},
    {1326, "24000", "Cursor is not open"},
    {1327, "42000", "Undeclared variable: "},
    {1328, "HY000", "Incorrect number of FETCH variables"},
    {1329, "02000", "No data - zero rows fetched, selected, or processed"},
    {1330, "42000", "Duplicate parameter: "},
    {1331, "42000", "Duplicate variable: "},
    {1332, "42000", "Duplicate condition: "},
    {1333, "42000", "Duplicate cursor: "},
    {1334, "HY000", "Failed to ALTER  "},
    {1335, "0A000", "Subquery value not supported"},
    {1336, "0A000", " is not allowed in stored function or trigger"},
    {1337, "42000", "Variable or condition declaration after cursor or handler declaration"},
    {1338, "42000", "Cursor declaration after handler declaration"},
    {1339, "20000", "Case not found for CASE statement"},
    {1340, "HY000", "Configuration file '' is too big"},
    {1341, "HY000", "Malformed file type header in file ''"},
    {1342, "HY000", "Unexpected end of file while parsing comment ''"},
    {1343, "HY000", "Error while parsing parameter '' (line: '')"},
    {1344, "HY000", "Unexpected end of file while skipping unknown parameter ''"},
    {1345, "HY000", "EXPLAIN/SHOW can not be issued; lacking privileges for underlying table"},
    {1346, "HY000", "File '' has unknown type '' in its header"},
    {1347, "HY000", "'.' is not "},
    {1348, "HY000", "Column '' is not updatable"},
    {1349, "HY000", "View's SELECT contains a subquery in the FROM clause"},
    {1350, "HY000", "View's SELECT contains a '' clause"},
    {1351, "HY000", "View's SELECT contains a variable or parameter"},
    {1352, "HY000", "View's SELECT refers to a temporary table ''"},
    {1353, "HY000", "View's SELECT and view's field list have different column counts"},
    {1354, "HY000", "View merge algorithm can't be used here for now (assumed undefined algorithm)"},
    {1355, "HY000", "View being updated does not have complete key of underlying table in it"},
    {1356, "HY000", "View '.' references invalid table(s) or column(s) or function(s) or definer/invoker of view lack rights to use them"},
    {1357, "HY000", "Can't drop or alter a  from within another stored routine"},
    {1358, "HY000", "GOTO is not allowed in a stored procedure handler"},
    {1359, "HY000", "Trigger already exists"},
    {1360, "HY000", "Trigger does not exist"},
    {1361, "HY000", "Trigger's '' is view or temporary table"},
    {1362, "HY000", "Updating of  row is not allowed in trigger"},
    {1363, "HY000", "There is no  row in  trigger"},
    {1364, "HY000", "Field '' doesn't have a default value"},
    {1365, "22012", "Division by 0"},
    {1366, "HY000", "Incorrect  value: '' for column '' at row "},
    {1367, "22007", "Illegal  '' value found during parsing"},
    {1368, "HY000", "CHECK OPTION on non-updatable view '.'"},
    {1369, "HY000", "CHECK OPTION failed '.'"},
    {1370, "42000", " command denied to user ''@'' for routine ''"},
    {1371, "HY000", "Failed purging old relay logs: "},
    {1372, "HY000", "Password hash should be a -digit hexadecimal number"},
    {1373, "HY000", "Target log not found in binlog index"},
    {1374, "HY000", "I/O error reading log index file"},
    {1375, "HY000", "Server configuration does not permit binlog purge"},
    {1376, "HY000", "Failed on fseek()"},
    {1377, "HY000", "Fatal error during log purge"},
    {1378, "HY000", "A purgeable log is in use, will not purge"},
    {1379, "HY000", "Unknown error during log purge"},
    {1380, "HY000", "Failed initializing relay log position: "},
    {1381, "HY000", "You are not using binary logging"},
    {1382, "HY000", "The '' syntax is reserved for purposes internal to the MySQL server"},
    {1383, "HY000", "WSAStartup Failed"},
    {1384, "HY000", "Can't handle procedures with different groups yet"},
    {1385, "HY000", "Select must have a group with this procedure"},
    {1386, "HY000", "Can't use ORDER clause with this procedure"},
    {1387, "HY000", "Binary logging and replication forbid changing the global server "},
    {1388, "HY000", "Can't map file: , errno: "},
    {1389, "HY000", "Wrong magic in "},
    {1390, "HY000", "Prepared statement contains too many placeholders"},
    {1391, "HY000", "Key part '' length cannot be 0"},
    {1392, "HY000", "View text checksum failed"},
    {1393, "HY000", "Can not modify more than one base table through a join view '.'"},
    {1394, "HY000", "Can not insert into join view '.' without fields list"},
    {1395, "HY000", "Can not delete from join view '.'"},
    {1396, "HY000", "Operation  failed for "},
    {1397, "XAE04", "XAER_NOTA: Unknown XID"},
    {1398, "XAE05", "XAER_INVAL: Invalid arguments (or unsupported command)"},
    {1399, "XAE07", "XAER_RMFAIL: The command cannot be executed when global transaction is in the  state"},
    {1400, "XAE09", "XAER_OUTSIDE: Some work is done outside global transaction"},
    {1401, "XAE03", "XAER_RMERR: Fatal error occurred in the transaction branch - check your data for consistency"},
    {1402, "XA100", "XA_RBROLLBACK: Transaction branch was rolled back"},
    {1403, "42000", "There is no such grant defined for user '' on host '' on routine ''"},
    {1404, "HY000", "Failed to grant EXECUTE and ALTER ROUTINE privileges"},
    {1405, "HY000", "Failed to revoke all privileges to dropped routine"},
    {1406, "22001", "Data too long for column '' at row "},
    {1407, "42000", "Bad SQLSTATE: ''"},
    {1408, "HY000", ": ready for connections. Version: '' socket: '' port:  "},
    {1409, "HY000", "Can't load value from file with fixed size rows to variable"},
    {1410, "42000", "You are not allowed to create a user with GRANT"},
    {1411, "HY000", "Incorrect  value: '' for function "},
    {1412, "HY000", "Table definition has changed, please retry transaction"},
    {1413, "42000", "Duplicate handler declared in the same block"},
    {1414, "42000", "OUT or INOUT argument  for routine  is not a variable or NEW pseudo-variable in BEFORE trigger"},
    {1415, "0A000", "Not allowed to return a result set from a "},
    {1416, "22003", "Cannot get geometry object from data you send to the GEOMETRY field"},
    {1417, "HY000", "A routine failed and has neither NO SQL nor READS SQL DATA in its declaration and binary logging is enabled; if non-transactional tables were updated, the binary log will miss their changes"},
    {1418, "HY000", "This function has none of DETERMINISTIC, NO SQL, or READS SQL DATA in its declaration and binary logging is enabled (you *might* want to use the less safe log_bin_trust_function_creators variable)"},
    {1419, "HY000", "You do not have the SUPER privilege and binary logging is enabled (you *might* want to use the less safe log_bin_trust_function_creators variable)"},
    {1420, "HY000", "You can't execute a prepared statement which has an open cursor associated with it. Reset the statement to re-execute it."},
    {1421, "HY000", "The statement () has no open cursor."},
    {1422, "HY000", "Explicit or implicit commit is not allowed in stored function or trigger."},
    {1423, "HY000", "Field of view '.' underlying table doesn't have a default value"},
    {1424, "HY000", "Recursive stored functions and triggers are not allowed."},
    {1425, "42000", "Too big scale  specified for column ''. Maximum is ."},
    {1426, "42000", "Too-big precision  specified for ''. Maximum is ."},
    {1427, "42000", "For float(M,D), double(M,D) or decimal(M,D), M must be >= D (column '')."},
    {1428, "HY000", "You can't combine write-locking of system tables with other tables or lock types"},
    {1429, "HY000", "Unable to connect to foreign data source: "},
    {1430, "HY000", "There was a problem processing the query on the foreign data source. Data source error: "},
    {1431, "HY000", "The foreign data source you are trying to reference does not exist. Data source error: "},
    {1432, "HY000", "Can't create federated table. The data source connection string '' is not in the correct format"},
    {1433, "HY000", "The data source connection string '' is not in the correct format"},
    {1434, "HY000", "Can't create federated table. Foreign data src error: "},
    {1435, "HY000", "Trigger in wrong schema"},
    {1436, "HY000", "Thread stack overrun:  bytes used of a  byte stack, and  bytes needed. Use 'mysqld --thread_stack=#' to specify a bigger stack."},
    {1437, "42000", "Routine body for '' is too long"},
    {1438, "HY000", "Cannot drop default keycache"},
    {1439, "42000", "Display width out of range for column '' (max = )"},
    {1440, "XAE08", "XAER_DUPID: The XID already exists"},
    {1441, "22008", "Datetime function:  field overflow"},
    {1442, "HY000", "Can't update table '' in stored function/trigger because it is already used by statement which invoked this stored function/trigger."},
    {1443, "HY000", "The definition of table '' prevents operation  on table ''."},
    {1444, "HY000", "The prepared statement contains a stored routine call that refers to that same statement. It's not allowed to execute a prepared statement in such a recursive manner"},
    {1445, "HY000", "Not allowed to set autocommit from a stored function or trigger"},
    {1446, "HY000", "Definer is not fully qualified"},
    {1447, "HY000", "View ''.'' has no definer information (old table format). Current user is used as definer. Please recreate the view!"},
    {1448, "HY000", "You need the SUPER privilege for creation view with ''@'' definer"},
    {1449, "HY000", "The user specified as a definer (''@'') does not exist"},
    {1450, "HY000", "Changing schema from '' to '' is not allowed."},
    {1451, "23000", "Cannot delete or update a parent row: a foreign key constraint fails ()"},
    {1452, "23000", "Cannot add or update a child row: a foreign key constraint fails ()"},
    {1453, "42000", "Variable '' must be quoted with `...`, or renamed"},
    {1454, "HY000", "No definer attribute for trigger ''.''. The trigger will be activated under the authorization of the invoker, which may have insufficient privileges. Please recreate the trigger."},
    {1455, "HY000", "'' has an old format, you should re-create the '' object(s)"},
    {1456, "HY000", "Recursive limit  (as set by the max_sp_recursion_depth variable) was exceeded for routine "},
    {1457, "HY000", "Failed to load routine . The table mysql.proc is missing, corrupt, or contains bad data (internal code )"},
    {1458, "42000", "Incorrect routine name ''"},
    {1459, "HY000", "Table upgrade required. Please do \"REPAIR TABLE ``\" or dump/reload to fix it!"},
    {1460, "42000", "AGGREGATE is not supported for stored functions"},
    {1461, "42000", "Can't create more than max_prepared_stmt_count statements (current value: )"},
    {1462, "HY000", "``.`` contains view recursion"},
    {1463, "42000", "Non-grouping field '' is used in  clause"},
    {1464, "HY000", "The used table type doesn't support SPATIAL indexes"},
    {1465, "HY000", "Triggers can not be created on system tables"},
    {1466, "HY000", "Leading spaces are removed from name ''"},
    {1467, "HY000", "Failed to read auto-increment value from storage engine"},
    {1468, "HY000", "user name"},
    {1469, "HY000", "host name"},
    {1470, "HY000", "String '' is too long for  (should be no longer than )"},
    {1471, "HY000", "The target table  of the  is not insertable-into"},
    {1472, "HY000", "Table '' is differently defined or of non-MyISAM type or doesn't exist"},
    {1473, "HY000", "Too high level of nesting for select"},
    {1474, "HY000", "Name '' has become ''"},
    {1475, "HY000", "First character of the FIELDS TERMINATED string is ambiguous; please use non-optional and non-empty FIELDS ENCLOSED BY"},
    {1476, "HY000", "The foreign server, , you are trying to create already exists."},
    {1477, "HY000", "The foreign server name you are trying to reference does not exist. Data source error: "},
    {1478, "HY000", "Table storage engine '' does not support the create option ''"},
    {1479, "HY000", "Syntax error:  PARTITIONING requires definition of VALUES  for each partition"},
    {1480, "HY000", "Only  PARTITIONING can use VALUES  in partition definition"},
    {1481, "HY000", "MAXVALUE can only be used in last partition definition"},
    {1482, "HY000", "Subpartitions can only be hash partitions and by key"},
    {1483, "HY000", "Must define subpartitions on all partitions if on one partition"},
    {1484, "HY000", "Wrong number of partitions defined, mismatch with previous setting"},
    {1485, "HY000", "Wrong number of subpartitions defined, mismatch with previous setting"},
    {1486, "HY000", "Constant, random or timezone-dependent expressions in (sub)partitioning function are not allowed"},
    {1487, "HY000", "Expression in RANGE/LIST VALUES must be constant"},
    {1488, "HY000", "Field in list of fields for partition function not found in table"},
    {1489, "HY000", "List of fields is only allowed in KEY partitions"},
    {1490, "HY000", "The partition info in the frm file is not consistent with what can be written into the frm file"},
    {1491, "HY000", "The  function returns the wrong type"},
    {1492, "HY000", "For  partitions each partition must be defined"},
    {1493, "HY000", "VALUES LESS THAN value must be strictly increasing for each partition"},
    {1494, "HY000", "VALUES value must be of same type as partition function"},
    {1495, "HY000", "Multiple definition of same constant in list partitioning"},
    {1496, "HY000", "Partitioning can not be used stand-alone in query"},
    {1497, "HY000", "The mix of handlers in the partitions is not allowed in this version of MySQL"},
    {1498, "HY000", "For the partitioned engine it is necessary to define all "},
    {1499, "HY000", "Too many partitions (including subpartitions) were defined"},
    {1500, "HY000", "It is only possible to mix RANGE/LIST partitioning with HASH/KEY partitioning for subpartitioning"},
    {1501, "HY000", "Failed to create specific handler file"},
    {1502, "HY000", "A BLOB field is not allowed in partition function"},
    {1503, "HY000", "A  must include all columns in the table's partitioning function"},
    {1504, "HY000", "Number of  = 0 is not an allowed value"},
    {1505, "HY000", "Partition management on a not partitioned table is not possible"},
    {1506, "HY000", "Foreign keys are not yet supported in conjunction with partitioning"},
    {1507, "HY000", "Error in list of partitions to "},
    {1508, "HY000", "Cannot remove all partitions, use DROP TABLE instead"},
    {1509, "HY000", "COALESCE PARTITION can only be used on HASH/KEY partitions"},
    {1510, "HY000", "REORGANIZE PARTITION can only be used to reorganize partitions not to change their numbers"},
    {1511, "HY000", "REORGANIZE PARTITION without parameters can only be used on auto-partitioned tables using HASH PARTITIONs"},
    {1512, "HY000", " PARTITION can only be used on RANGE/LIST partitions"},
    {1513, "HY000", "Trying to Add partition(s) with wrong number of subpartitions"},
    {1514, "HY000", "At least one partition must be added"},
    {1515, "HY000", "At least one partition must be coalesced"},
    {1516, "HY000", "More partitions to reorganize than there are partitions"},
    {1517, "HY000", "Duplicate partition name "},
    {1518, "HY000", "It is not allowed to shut off binlog on this command"},
    {1519, "HY000", "When reorganizing a set of partitions they must be in consecutive order"},
    {1520, "HY000", "Reorganize of range partitions cannot change total ranges except for last partition where it can extend the range"},
    {1521, "HY000", "Partition function not supported in this version for this handler"},
    {1522, "HY000", "Partition state cannot be defined from CREATE/ALTER TABLE"},
    {1523, "HY000", "The  handler only supports 32 bit integers in VALUES"},
    {1524, "HY000", "Plugin '' is not loaded"},
    {1525, "HY000", "Incorrect  value: ''"},
    {1526, "HY000", "Table has no partition for value "},
    {1527, "HY000", "It is not allowed to specify  more than once"},
    {1528, "HY000", "Failed to create "},
    {1529, "HY000", "Failed to drop "},
    {1530, "HY000", "The handler doesn't support autoextend of tablespaces"},
    {1531, "HY000", "A size parameter was incorrectly specified, either number or on the form 10M"},
    {1532, "HY000", "The size number was correct but we don't allow the digit part to be more than 2 billion"},
    {1533, "HY000", "Failed to alter: "},
    {1534, "HY000", "Writing one row to the row-based binary log failed"},
    {1535, "HY000", "Table definition on master and slave does not match: "},
    {1536, "HY000", "Slave running with --log-slave-updates must use row-based binary logging to be able to replicate row-based binary log events"},
    {1537, "HY000", "Event '' already exists"},
    {1538, "HY000", "Failed to store event . Error code  from storage engine."},
    {1539, "HY000", "Unknown event ''"},
    {1540, "HY000", "Failed to alter event ''"},
    {1541, "HY000", "Failed to drop "},
    {1542, "HY000", "INTERVAL is either not positive or too big"},
    {1543, "HY000", "ENDS is either invalid or before STARTS"},
    {1544, "HY000", "Event execution time is in the past. Event has been disabled"},
    {1545, "HY000", "Failed to open mysql.event"},
    {1546, "HY000", "No datetime expression provided"},
    {1547, "HY000", "Column count of mysql. is wrong. Expected , found . The table is probably corrupted"},
    {1548, "HY000", "Cannot load from mysql.. The table is probably corrupted"},
    {1549, "HY000", "Failed to delete the event from mysql.event"},
    {1550, "HY000", "Error during compilation of event's body"},
    {1551, "HY000", "Same old and new event name"},
    {1552, "HY000", "Data for column '' too long"},
    {1553, "HY000", "Cannot drop index '': needed in a foreign key constraint"},
    {1554, "HY000", "The syntax '' is deprecated and will be removed in MySQL . Please use  instead"},
    {1555, "HY000", "You can't write-lock a log table. Only read access is possible"},
    {1556, "HY000", "You can't use locks with log tables."},
    {1557, "23000", "Upholding foreign key constraints for table '', entry '', key  would lead to a duplicate entry"},
    {1558, "HY000", "Column count of mysql. is wrong. Expected , found . Created with MySQL , now running . Please use mysql_upgrade to fix this error."},
    {1559, "HY000", "Cannot switch out of the row-based binary log format when the session has open temporary tables"},
    {1560, "HY000", "Cannot change the binary logging format inside a stored function or trigger"},
    {1561, "HY000", "The NDB cluster engine does not support changing the binlog format on the fly yet"},
    {1562, "HY000", "Cannot create temporary table with partitions"},
    {1563, "HY000", "Partition constant is out of partition function domain"},
    {1564, "HY000", "This partition function is not allowed"},
    {1565, "HY000", "Error in DDL log"},
    {1566, "HY000", "Not allowed to use NULL value in VALUES LESS THAN"},
    {1567, "HY000", "Incorrect partition name"},
    {1568, "25001", "Transaction characteristics can't be changed while a transaction is in progress"},
    {1569, "HY000", "ALTER TABLE causes auto_increment resequencing, resulting in duplicate entry '' for key ''"},
    {1570, "HY000", "Internal scheduler error "},
    {1571, "HY000", "Error during starting/stopping of the scheduler. Error code "},
    {1572, "HY000", "Engine cannot be used in partitioned tables"},
    {1573, "HY000", "Cannot activate '' log"},
    {1574, "HY000", "The server was not built with row-based replication"},
    {1575, "HY000", "Decoding of base64 string failed"},
    {1576, "HY000", "Recursion of EVENT DDL statements is forbidden when body is present"},
    {1577, "HY000", "Cannot proceed because system tables used by Event Scheduler were found damaged at server start"},
    {1578, "HY000", "Only integers allowed as number here"},
    {1579, "HY000", "This storage engine cannot be used for log tables"},
    {1580, "HY000", "You cannot '' a log table if logging is enabled"},
    {1581, "HY000", "Cannot rename ''. When logging enabled, rename to/from log table must rename two tables: the log table to an archive table and another table back to ''"},
    {1582, "42000", "Incorrect parameter count in the call to native function ''"},
    {1583, "42000", "Incorrect parameters in the call to native function ''"},
    {1584, "42000", "Incorrect parameters in the call to stored function "},
    {1585, "HY000", "This function '' has the same name as a native function"},
    {1586, "23000", "Duplicate entry '' for key ''"},
    {1587, "HY000", "Too many files opened, please execute the command again"},
    {1588, "HY000", "Event execution time is in the past and ON COMPLETION NOT PRESERVE is set. The event was dropped immediately after creation."},
    {1589, "HY000", "Event execution time is in the past and ON COMPLETION NOT PRESERVE is set. The event was not changed. Specify a time in the future."},
    {1590, "HY000", "The incident  occured on the master. Message: "},
    {1591, "HY000", "Table has no partition for some existing values"},
    {1592, "HY000", "Unsafe statement written to the binary log using statement format since BINLOG_FORMAT = STATEMENT. "},
    {1593, "HY000", "Fatal error: "},
    {1594, "HY000", "Relay log read failure: "},
    {1595, "HY000", "Relay log write failure: "},
    {1596, "HY000", "Failed to create "},
    {1597, "HY000", "Master command  failed: "},
    {1598, "HY000", "Binary logging not possible. Message: "},
    {1599, "HY000", "View ``.`` has no creation context"},
    {1600, "HY000", "Creation context of view ``.`' is invalid"},
    {1601, "HY000", "Creation context of stored routine ``.`` is invalid"},
    {1602, "HY000", "Corrupted TRG file for table ``.``"},
    {1603, "HY000", "Triggers for table ``.`` have no creation context"},
    {1604, "HY000", "Trigger creation context of table ``.`` is invalid"},
    {1605, "HY000", "Creation context of event ``.`` is invalid"},
    {1606, "HY000", "Cannot open table for trigger ``.``"},
    {1607, "HY000", "Cannot create stored routine ``. Check warnings"},
    {1608, "HY000", "Ambiguous slave modes combination. "},
    {1609, "HY000", "The BINLOG statement of type `` was not preceded by a format description BINLOG statement."},
    {1610, "HY000", "Corrupted replication event was detected"},
    {1611, "HY000", "Invalid column reference () in LOAD DATA"},
    {1612, "HY000", "Being purged log  was not found"},
    {1613, "XA106", "XA_RBTIMEOUT: Transaction branch was rolled back: took too long"},
    {1614, "XA102", "XA_RBDEADLOCK: Transaction branch was rolled back: deadlock was detected"},
    {1615, "HY000", "Prepared statement needs to be re-prepared"},
    {1616, "HY000", "DELAYED option not supported for table ''"},
    {1617, "HY000", "The master info structure does not exist"},
    {1618, "HY000", "<> option ignored"},
    {1619, "HY000", "Built-in plugins cannot be deleted"},
    {1620, "HY000", "Plugin is busy and will be uninstalled on shutdown"},
    {1621, "HY000", " variable '' is read-only. Use SET  to assign the value"},
    {1622, "HY000", "Storage engine  does not support rollback for this statement. Transaction rolled back and must be restarted"},
    {1623, "HY000", "Unexpected master's heartbeat data: "},
    {1624, "HY000", "The requested value for the heartbeat period is either negative or exceeds the maximum allowed ( seconds)."},
    {1625, "HY000", "Bad schema for mysql.ndb_replication table. Message: "},
    {1626, "HY000", "Error in parsing conflict function. Message: "},
    {1627, "HY000", "Write to exceptions table failed. Message: "},
    {1628, "HY000", "Comment for table '' is too long (max = )"},
    {1629, "HY000", "Comment for field '' is too long (max = )"},
    {1630, "42000", "FUNCTION  does not exist. Check the 'Function Name Parsing and Resolution' section in the Reference Manual"},
    {1631, "HY000", "Database"},
    {1632, "HY000", "Table"},
    {1633, "HY000", "Partition"},
    {1634, "HY000", "Subpartition"},
    {1635, "HY000", "Temporary"},
    {1636, "HY000", "Renamed"},
    {1637, "HY000", "Too many active concurrent transactions"},
    {1638, "HY000", "Non-ASCII separator arguments are not fully supported"},
    {1639, "HY000", "debug sync point wait timed out"},
    {1640, "HY000", "debug sync point hit limit reached"},
    {1641, "42000", "Duplicate condition information item ''"},
    {1642, "01000", "Unhandled user-defined warning condition"},
    {1643, "02000", "Unhandled user-defined not found condition"},
    {1644, "HY000", "Unhandled user-defined exception condition"},
    {1645, "0K000", "RESIGNAL when handler not active"},
    {1646, "HY000", "SIGNAL/RESIGNAL can only use a CONDITION defined with SQLSTATE"},
    {1647, "HY000", "Data truncated for condition item ''"},
    {1648, "HY000", "Data too long for condition item ''"},
    {1649, "HY000", "Unknown locale: ''"},
    {1650, "HY000", "The requested server id  clashes with the slave startup option --replicate-same-server-id"},
    {1651, "HY000", "Query cache is disabled; restart the server with query_cache_type=1 to enable it"},
    {1652, "HY000", "Duplicate partition field name ''"},
    {1653, "HY000", "Inconsistency in usage of column lists for partitioning"},
    {1654, "HY000", "Partition column values of incorrect type"},
    {1655, "HY000", "Too many fields in ''"},
    {1656, "HY000", "Cannot use MAXVALUE as value in VALUES IN"},
    {1657, "HY000", "Cannot have more than one value for this type of  partitioning"},
    {1658, "HY000", "Row expressions in VALUES IN only allowed for multi-field column partitioning"},
    {1659, "HY000", "Field '' is of a not allowed type for this type of partitioning"},
    {1660, "HY000", "The total length of the partitioning fields is too large"},
    {1661, "HY000", "Cannot execute statement: impossible to write to binary log since both row-incapable engines and statement-incapable engines are involved."},
    {1662, "HY000", "Cannot execute statement: impossible to write to binary log since BINLOG_FORMAT = ROW and at least one table uses a storage engine limited to statement-based logging."},
    {1663, "HY000", "Cannot execute statement: impossible to write to binary log since statement is unsafe, storage engine is limited to statement-based logging, and BINLOG_FORMAT = MIXED. "},
    {1664, "HY000", "Cannot execute statement: impossible to write to binary log since statement is in row format and at least one table uses a storage engine limited to statement-based logging."},
    {1665, "HY000", "Cannot execute statement: impossible to write to binary log since BINLOG_FORMAT = STATEMENT and at least one table uses a storage engine limited to row-based logging."},
    {1666, "HY000", "Cannot execute statement: impossible to write to binary log since statement is in row format and BINLOG_FORMAT = STATEMENT."},
    {1667, "HY000", "Cannot execute statement: impossible to write to binary log since more than one engine is involved and at least one engine is self-logging."},
    {1668, "HY000", "The statement is unsafe because it uses a LIMIT clause. This is unsafe because the set of rows included cannot be predicted."},
    {1669, "HY000", "The statement is unsafe because it uses INSERT DELAYED. This is unsafe because the times when rows are inserted cannot be predicted."},
    {1670, "HY000", "The statement is unsafe because it uses the general log, slow query log, or performance_schema table(s). This is unsafe because system tables may differ on slaves."},
    {1671, "HY000", "Statement is unsafe because it invokes a trigger or a stored function that inserts into an AUTO_INCREMENT column. Inserted values cannot be logged correctly."},
    {1672, "HY000", "Statement is unsafe because it uses a UDF which may not return the same value on the slave."},
    {1673, "HY000", "Statement is unsafe because it uses a system variable that may have a different value on the slave."},
    {1674, "HY000", "Statement is unsafe because it uses a system function that may return a different value on the slave."},
    {1675, "HY000", "Statement is unsafe because it accesses a non-transactional table after accessing a transactional table within the same transaction."},
    {1676, "HY000", " Statement: "},
    {1677, "HY000", "Column  of table '.' cannot be converted from type '' to type ''"},
    {1678, "HY000", "Can't create conversion table for table '.'"},
    {1679, "HY000", "Cannot modify @@session.binlog_format inside a transaction"},
    {1680, "HY000", "The path specified for  is too long."},
    {1681, "HY000", "'' is deprecated and will be removed in a future release."},
    {1682, "HY000", "Native table ''.'' has the wrong structure"},
    {1683, "HY000", "Invalid performance_schema usage."},
    {1684, "HY000", "Table ''.'' was skipped since its definition is being modified by concurrent DDL statement"},
    {1685, "HY000", "Cannot modify @@session.binlog_direct_non_transactional_updates inside a transaction"},
    {1686, "HY000", "Cannot change the binlog direct flag inside a stored function or trigger"},
    {1687, "42000", "A SPATIAL index may only contain a geometrical type column"},
    {1688, "HY000", "Comment for index '' is too long (max = )"},
    {1689, "HY000", "Wait on a lock was aborted due to a pending exclusive lock"},
    {1690, "22003", " value is out of range in ''"},
    {1691, "HY000", "A variable of a non-integer based type in LIMIT clause"},
    {1692, "HY000", "Mixing self-logging and non-self-logging engines in a statement is unsafe."},
    {1693, "HY000", "Statement accesses nontransactional table as well as transactional or temporary table, and writes to any of them."},
    {1694, "HY000", "Cannot modify @@session.sql_log_bin inside a transaction"},
    {1695, "HY000", "Cannot change the sql_log_bin inside a stored function or trigger"},
    {1696, "HY000", "Failed to read from the .par file"},
    {1697, "HY000", "VALUES value for partition '' must have type INT"},
    {1698, "28000", "Access denied for user ''@''"},
    {1699, "HY000", "SET PASSWORD has no significance for users authenticating via plugins"},
    {1700, "HY000", "GRANT with IDENTIFIED WITH is illegal because the user  already exists"},
    {1701, "42000", "Cannot truncate a table referenced in a foreign key constraint ()"},
    {1702, "HY000", "Plugin '' is force_plus_permanent and can not be unloaded"},
    {1703, "HY000", "The requested value for the heartbeat period is less than 1 millisecond. The value is reset to 0, meaning that heartbeating will effectively be disabled."},
    {1704, "HY000", "The requested value for the heartbeat period exceeds the value of `slave_net_timeout' seconds. A sensible value for the period should be less than the timeout."},
    {1705, "HY000", "Multi-row statements required more than 'max_binlog_stmt_cache_size' bytes of storage; increase this mysqld variable and try again"},
    {1706, "HY000", "Primary key/partition key update is not allowed since the table is updated both as '' and ''."},
    {1707, "HY000", "Table rebuild required. Please do \"ALTER TABLE `` FORCE\" or dump/reload to fix it!"},
    {1708, "HY000", "The value of '' should be no less than the value of ''"},
    {1709, "HY000", "Index column size too large. The maximum column size is  bytes."},
    {1710, "HY000", "Trigger '' has an error in its body: ''"},
    {1711, "HY000", "Unknown trigger has an error in its body: ''"},
    {1712, "HY000", "Index  is corrupted"},
    {1713, "HY000", "Undo log record is too big."},
    {1714, "HY000", "INSERT IGNORE... SELECT is unsafe because the order in which rows are retrieved by the SELECT determines which (if any) rows are ignored. This order cannot be predicted and may differ on master and the slave."},
    {1715, "HY000", "INSERT... SELECT... ON DUPLICATE KEY UPDATE is unsafe because the order in which rows are retrieved by the SELECT determines which (if any) rows are updated. This order cannot be predicted and may differ on master and the slave."},
    {1716, "HY000", "REPLACE... SELECT is unsafe because the order in which rows are retrieved by the SELECT determines which (if any) rows are replaced. This order cannot be predicted and may differ on master and the slave."},
    {1717, "HY000", "CREATE... IGNORE SELECT is unsafe because the order in which rows are retrieved by the SELECT determines which (if any) rows are ignored. This order cannot be predicted and may differ on master and the slave."},
    {1718, "HY000", "CREATE... REPLACE SELECT is unsafe because the order in which rows are retrieved by the SELECT determines which (if any) rows are replaced. This order cannot be predicted and may differ on master and the slave."},
    {1719, "HY000", "UPDATE IGNORE is unsafe because the order in which rows are updated determines which (if any) rows are ignored. This order cannot be predicted and may differ on master and the slave."},
    {1720, "HY000", "Plugin '' is marked as not dynamically uninstallable. You have to stop the server to uninstall it."},
    {1721, "HY000", "Plugin '' is marked as not dynamically installable. You have to stop the server to install it."},
    {1722, "HY000", "Statements writing to a table with an auto-increment column after selecting from another table are unsafe because the order in which rows are retrieved determines what (if any) rows will be written. This order cannot be predicted and may differ on master and the slave."},
    {1723, "HY000", "CREATE TABLE... SELECT... on a table with an auto-increment column is unsafe because the order in which rows are retrieved by the SELECT determines which (if any) rows are inserted. This order cannot be predicted and may differ on master and the slave."},
    {1724, "HY000", "INSERT... ON DUPLICATE KEY UPDATE on a table with more than one UNIQUE KEY is unsafe"},
    {1725, "HY000", "Table is being used in foreign key check."},
    {1726, "HY000", "Storage engine '' does not support system tables. [.]"},
    {1727, "HY000", "INSERT into autoincrement field which is not the first part in the composed primary key is unsafe."},
    {1728, "HY000", "Cannot load from .. The table is probably corrupted"},
    {1729, "HY000", "The requested value  for the master delay exceeds the maximum "},
    {1730, "HY000", "Only Format_description_log_event and row events are allowed in BINLOG statements (but  was provided)"},
    {1731, "HY000", "Non matching attribute '' between partition and table"},
    {1732, "HY000", "Table to exchange with partition is partitioned: ''"},
    {1733, "HY000", "Table to exchange with partition is temporary: ''"},
    {1734, "HY000", "Subpartitioned table, use subpartition instead of partition"},
    {1735, "HY000", "Unknown partition '' in table ''"},
    {1736, "HY000", "Tables have different definitions"},
    {1737, "HY000", "Found a row that does not match the partition"},
    {1738, "HY000", "Option binlog_cache_size () is greater than max_binlog_cache_size (); setting binlog_cache_size equal to max_binlog_cache_size."},
    {1739, "HY000", "Cannot use  access on index '' due to type or collation conversion on field ''"},
    {1740, "HY000", "Table to exchange with partition has foreign key references: ''"},
    {1741, "HY000", "Key value '' was not found in table '.'"},
    {1742, "HY000", "Data for column '' too long"},
    {1743, "HY000", "Replication event checksum verification failed while reading from network."},
    {1744, "HY000", "Replication event checksum verification failed while reading from a log file."},
    {1745, "HY000", "Option binlog_stmt_cache_size () is greater than max_binlog_stmt_cache_size (); setting binlog_stmt_cache_size equal to max_binlog_stmt_cache_size."},
    {1746, "HY000", "Can't update table '' while '' is being created."},
    {1747, "HY000", "PARTITION () clause on non partitioned table"},
    {1748, "HY000", "Found a row not matching the given partition set"},
    {1749, "HY000", "partition '' doesn't exist"},
    {1750, "HY000", "Failure while changing the type of replication repository: ."},
    {1751, "HY000", "The creation of some temporary tables could not be rolled back."},
    {1752, "HY000", "Some temporary tables were dropped, but these operations could not be rolled back."},
    {1753, "HY000", " is not supported in multi-threaded slave mode. "},
    {1754, "HY000", "The number of modified databases exceeds the maximum ; the database names will not be included in the replication event metadata."},
    {1755, "HY000", "Cannot execute the current event group in the parallel mode. Encountered event , relay-log name , position  which prevents execution of this event group in parallel mode. Reason: ."},
    {1756, "HY000", ""},
    {1757, "HY000", "FULLTEXT index is not supported for partitioned tables."},
    {1758, "35000", "Invalid condition number"},
    {1759, "HY000", "Sending passwords in plain text without SSL/TLS is extremely insecure."},
    {1760, "HY000", "Storing MySQL user name or password information in the master info repository is not secure and is therefore not recommended. Please consider using the USER and PASSWORD connection options for START SLAVE; see the 'START SLAVE Syntax' in the MySQL Manual for more information."},
    {1761, "23000", "Foreign key constraint for table '', record '' would lead to a duplicate entry in table '', key ''"},
    {1762, "23000", "Foreign key constraint for table '', record '' would lead to a duplicate entry in a child table"},
    {1763, "HY000", "Setting authentication options is not possible when only the Slave SQL Thread is being started."},
    {1764, "HY000", "The table does not have FULLTEXT index to support this query"},
    {1765, "HY000", "The system variable  cannot be set in stored functions or triggers."},
    {1766, "HY000", "The system variable  cannot be set when there is an ongoing transaction."},
    {1767, "HY000", "The system variable @@SESSION.GTID_NEXT has the value , which is not listed in @@SESSION.GTID_NEXT_LIST."},
    {1768, "HY000", "The system variable @@SESSION.GTID_NEXT cannot change inside a transaction."},
    {1769, "HY000", "The statement 'SET ' cannot invoke a stored function."},
    {1770, "HY000", "The system variable @@SESSION.GTID_NEXT cannot be 'AUTOMATIC' when @@SESSION.GTID_NEXT_LIST is non-NULL."},
    {1771, "HY000", "Skipping transaction  because it has already been executed and logged."},
    {1772, "HY000", "Malformed GTID set specification ''."},
    {1773, "HY000", "Malformed GTID set encoding."},
    {1774, "HY000", "Malformed GTID specification ''."},
    {1775, "HY000", "Impossible to generate Global Transaction Identifier: the integer component reached the maximal value. Restart the server with a new server_uuid."},
    {1776, "HY000", "Parameters MASTER_LOG_FILE, MASTER_LOG_POS, RELAY_LOG_FILE and RELAY_LOG_POS cannot be set when MASTER_AUTO_POSITION is active."},
    {1777, "HY000", "CHANGE MASTER TO MASTER_AUTO_POSITION = 1 can only be executed when @@GLOBAL.GTID_MODE = ON."},
    {1778, "HY000", "Cannot execute statements with implicit commit inside a transaction when @@SESSION.GTID_NEXT == 'UUID:NUMBER'."},
    {1779, "HY000", "@@GLOBAL.GTID_MODE = ON or UPGRADE_STEP_2 requires @@GLOBAL.ENFORCE_GTID_CONSISTENCY = 1."},
    {1780, "HY000", "@@GLOBAL.GTID_MODE = ON or ON_PERMISSIVE or OFF_PERMISSIVE requires --log-bin and --log-slave-updates."},
    {1781, "HY000", "@@SESSION.GTID_NEXT cannot be set to UUID:NUMBER when @@GLOBAL.GTID_MODE = OFF."},
    {1782, "HY000", "@@SESSION.GTID_NEXT cannot be set to ANONYMOUS when @@GLOBAL.GTID_MODE = ON."},
    {1783, "HY000", "@@SESSION.GTID_NEXT_LIST cannot be set to a non-NULL value when @@GLOBAL.GTID_MODE = OFF."},
    {1784, "HY000", "Found a Gtid_log_event or Previous_gtids_log_event when @@GLOBAL.GTID_MODE = OFF."},
    {1785, "HY000", "Statement violates GTID consistency: Updates to non-transactional tables can only be done in either autocommitted statements or single-statement transactions, and never in the same statement as updates to transactional tables."},
    {1786, "HY000", "Statement violates GTID consistency: CREATE TABLE ... SELECT."},
    {1787, "HY000", "Statement violates GTID consistency: CREATE TEMPORARY TABLE and DROP TEMPORARY TABLE can only be executed outside transactional context. These statements are also not allowed in a function or trigger because functions and triggers are also considered to be multi-statement transactions."},
    {1788, "HY000", "The value of @@GLOBAL.GTID_MODE can only be changed one step at a time: OFF <-> OFF_PERMISSIVE <-> ON_PERMISSIVE <-> ON. Also note that this value must be stepped up or down simultaneously on all servers. See the Manual for instructions."},
    {1789, "HY000", "The slave is connecting using CHANGE MASTER TO MASTER_AUTO_POSITION = 1, but the master has purged binary logs containing GTIDs that the slave requires."},
    {1790, "HY000", "@@SESSION.GTID_NEXT cannot be changed by a client that owns a GTID. The client owns . Ownership is released on COMMIT or ROLLBACK."},
    {1791, "HY000", "Unknown EXPLAIN format name: ''"},
    {1792, "25006", "Cannot execute statement in a READ ONLY transaction."},
    {1793, "HY000", "Comment for table partition '' is too long (max = )"},
    {1794, "HY000", "Slave is not configured or failed to initialize properly. You must at least set --server-id to enable either a master or a slave. Additional error messages can be found in the MySQL error log."},
    {1795, "HY000", "InnoDB presently supports one FULLTEXT index creation at a time"},
    {1796, "HY000", "Cannot create FULLTEXT index on temporary InnoDB table"},
    {1797, "HY000", "Column '' is of wrong type for an InnoDB FULLTEXT index"},
    {1798, "HY000", "Index '' is of wrong type for an InnoDB FULLTEXT index"},
    {1799, "HY000", "Creating index '' required more than 'innodb_online_alter_log_max_size' bytes of modification log. Please try again."},
    {1800, "HY000", "Unknown ALGORITHM ''"},
    {1801, "HY000", "Unknown LOCK type ''"},
    {1802, "HY000", "CHANGE MASTER cannot be executed when the slave was stopped with an error or killed in MTS mode. Consider using RESET SLAVE or START SLAVE UNTIL."},
    {1803, "HY000", "Cannot recover after SLAVE errored out in parallel execution mode. Additional error messages can be found in the MySQL error log."},
    {1804, "HY000", "Cannot clean up worker info tables. Additional error messages can be found in the MySQL error log."},
    {1805, "HY000", "Column count of . is wrong. Expected , found . The table is probably corrupted"},
    {1806, "HY000", "Slave must silently retry current transaction"},
    {1807, "HY000", "There is a foreign key check running on table ''. Cannot discard the table."},
    {1808, "HY000", "Schema mismatch ()"},
    {1809, "HY000", "Table '' in system tablespace"},
    {1810, "HY000", "IO Read error: (, ) "},
    {1811, "HY000", "IO Write error: (, ) "},
    {1812, "HY000", "Tablespace is missing for table ."},
    {1813, "HY000", "Tablespace '' exists."},
    {1814, "HY000", "Tablespace has been discarded for table ''"},
    {1815, "HY000", "Internal error: "},
    {1816, "HY000", "ALTER TABLE  IMPORT TABLESPACE failed with error  : ''"},
    {1817, "HY000", "Index corrupt: "},
    {1818, "HY000", "Supports only YEAR or YEAR(4) column."},
    {1819, "HY000", "Your password does not satisfy the current policy requirements"},
    {1820, "HY000", "You must reset your password using ALTER USER statement before executing this statement."},
    {1821, "HY000", "Failed to add the foreign key constaint. Missing index for constraint '' in the foreign table ''"},
    {1822, "HY000", "Failed to add the foreign key constaint. Missing index for constraint '' in the referenced table ''"},
    {1823, "HY000", "Failed to add the foreign key constraint '' to system tables"},
    {1824, "HY000", "Failed to open the referenced table ''"},
    {1825, "HY000", "Failed to add the foreign key constraint on table ''. Incorrect options in FOREIGN KEY constraint ''"},
    {1826, "HY000", "Duplicate foreign key constraint name ''"},
    {1827, "HY000", "The password hash doesn't have the expected format. Check if the correct password algorithm is being used with the PASSWORD() function."},
    {1828, "HY000", "Cannot drop column '': needed in a foreign key constraint ''"},
    {1829, "HY000", "Cannot drop column '': needed in a foreign key constraint '' of table ''"},
    {1830, "HY000", "Column '' cannot be NOT NULL: needed in a foreign key constraint '' SET NULL"},
    {1831, "HY000", "Duplicate index '' defined on the table '.'. This is deprecated and will be disallowed in a future release."},
    {1832, "HY000", "Cannot change column '': used in a foreign key constraint ''"},
    {1833, "HY000", "Cannot change column '': used in a foreign key constraint '' of table ''"},
    {1834, "HY000", "Cannot delete rows from table which is parent in a foreign key constraint '' of table ''"},
    {1835, "HY000", "Malformed communication packet."},
    {1836, "HY000", "Running in read-only mode"},
    {1837, "HY000", "When @@SESSION.GTID_NEXT is set to a GTID, you must explicitly set it to a different value after a COMMIT or ROLLBACK. Please check GTID_NEXT variable manual page for detailed explanation. Current @@SESSION.GTID_NEXT is ''."},
    {1838, "HY000", "The system variable  cannot be set in stored procedures."},
    {1839, "HY000", "@@GLOBAL.GTID_PURGED can only be set when @@GLOBAL.GTID_MODE = ON."},
    {1840, "HY000", "@@GLOBAL.GTID_PURGED can only be set when @@GLOBAL.GTID_EXECUTED is empty."},
    {1841, "HY000", "@@GLOBAL.GTID_PURGED can only be set when there are no ongoing transactions (not even in other clients)."},
    {1842, "HY000", "@@GLOBAL.GTID_PURGED was changed from '' to ''."},
    {1843, "HY000", "@@GLOBAL.GTID_EXECUTED was changed from '' to ''."},
    {1844, "HY000", "Cannot execute statement: impossible to write to binary log since BINLOG_FORMAT = STATEMENT, and both replicated and non replicated tables are written to."},
    {1845, "0A000", " is not supported for this operation. Try ."},
    {1846, "0A000", " is not supported. Reason: . Try ."},
    {1847, "HY000", "COPY algorithm requires a lock"},
    {1848, "HY000", "Partition specific operations do not yet support LOCK/ALGORITHM"},
    {1849, "HY000", "Columns participating in a foreign key are renamed"},
    {1850, "HY000", "Cannot change column type INPLACE"},
    {1851, "HY000", "Adding foreign keys needs foreign_key_checks=OFF"},
    {1852, "HY000", "Creating unique indexes with IGNORE requires COPY algorithm to remove duplicate rows"},
    {1853, "HY000", "Dropping a primary key is not allowed without also adding a new primary key"},
    {1854, "HY000", "Adding an auto-increment column requires a lock"},
    {1855, "HY000", "Cannot replace hidden FTS_DOC_ID with a user-visible one"},
    {1856, "HY000", "Cannot drop or rename FTS_DOC_ID"},
    {1857, "HY000", "Fulltext index creation requires a lock"},
    {1858, "HY000", "sql_slave_skip_counter can not be set when the server is running with @@GLOBAL.GTID_MODE = ON. Instead, for each transaction that you want to skip, generate an empty transaction with the same GTID as the transaction"},
    {1859, "23000", "Duplicate entry for key ''"},
    {1860, "HY000", "Long database name and identifier for object resulted in path length exceeding  characters. Path: ''."},
    {1861, "HY000", "cannot silently convert NULL values, as required in this SQL_MODE"},
    {1862, "HY000", "Your password has expired. To log in you must change it using a client that supports expired passwords."},
    {1863, "HY000", "Found a row in wrong partition "},
    {1864, "HY000", "Cannot schedule event , relay-log name , position  to Worker thread because its size  exceeds  of slave_pending_jobs_size_max."},
    {1865, "HY000", "Cannot CREATE FULLTEXT INDEX WITH PARSER on InnoDB table"},
    {1866, "HY000", "The binary log file '' is logically corrupted: "},
    {1867, "HY000", "file  was not purged because it was being read by  thread(s), purged only  out of  files."},
    {1868, "HY000", "file  was not purged because it is the active log file."},
    {1869, "HY000", "Auto-increment value in UPDATE conflicts with internally generated values"},
    {1870, "HY000", "Row events are not logged for  statements that modify BLACKHOLE tables in row format. Table(s): ''"},
    {1871, "HY000", "Slave failed to initialize master info structure from the repository"},
    {1872, "HY000", "Slave failed to initialize relay log info structure from the repository"},
    {1873, "28000", "Access denied trying to change to user ''@'' (using password: ). Disconnecting."},
    {1874, "HY000", "InnoDB is in read only mode."},
    {1875, "HY000", "STOP SLAVE command execution is incomplete: Slave SQL thread got the stop signal, thread is busy, SQL thread will stop once the current task is complete."},
    {1876, "HY000", "STOP SLAVE command execution is incomplete: Slave IO thread got the stop signal, thread is busy, IO thread will stop once the current task is complete."},
    {1877, "HY000", "Operation cannot be performed. The table '.' is missing, corrupt or contains bad data."},
    {1878, "HY000", "Temporary file write failure."},
    {1879, "HY000", "Upgrade index name failed, please use create index(alter table) algorithm copy to rebuild index."},
    {1880, "HY000", "TIME/TIMESTAMP/DATETIME columns of old format have been upgraded to the new format."},
    {1881, "HY000", "Operation not allowed when innodb_forced_recovery > 0."},
    {1882, "HY000", "The initialization vector supplied to  is too short. Must be at least  bytes long"},
    {1883, "HY000", "Plugin '' cannot be uninstalled now. "},
    {1884, "HY000", "Cannot execute statement because it needs to be written to the binary log as multiple statements, and this is not allowed when @@SESSION.GTID_NEXT == 'UUID:NUMBER'."},
    {1885, "HY000", "Slave has more GTIDs than the master has, using the master's SERVER_UUID. This may indicate that the end of the binary log was truncated or that the last binary log file was lost, e.g., after a power or disk failure when sync_binlog != 1. The master may or may not have rolled back transactions that were already replicated to the slave. Suggest to replicate any transactions that master has rolled back from slave to master, and/or commit empty transactions on master to account for transactions that have been committed on master but are not included in GTID_EXECUTED."},
    {1886, NULL, NULL},
    {1887, NULL, NULL},
    {1888, NULL, NULL},
    {1889, NULL, NULL},
    {1890, NULL, NULL},
    {1891, NULL, NULL},
    {1892, NULL, NULL},
    {1893, NULL, NULL},
    {1894, NULL, NULL},
    {1895, NULL, NULL},
    {1896, NULL, NULL},
    {1897, NULL, NULL},
    {1898, NULL, NULL},
    {1899, NULL, NULL},
    {1900, NULL, NULL},
    {1901, NULL, NULL},
    {1902, NULL, NULL},
    {1903, NULL, NULL},
    {1904, NULL, NULL},
    {1905, NULL, NULL},
    {1906, "HY000", "This operation cannot be performed with a running slave io thread; run STOP SLAVE IO_THREAD first."},
    {1907, NULL, NULL},
    {1908, NULL, NULL},
    {1909, NULL, NULL},
    {1910, NULL, NULL},
    {1911, NULL, NULL},
    {1912, NULL, NULL},
    {1913, NULL, NULL},
    {1914, NULL, NULL},
    {1915, NULL, NULL},
    {1916, NULL, NULL},
    {1917, NULL, NULL},
    {1918, NULL, NULL},
    {1919, NULL, NULL},
    {1920, NULL, NULL},
    {1921, NULL, NULL},
    {1922, NULL, NULL},
    {1923, NULL, NULL},
    {1924, NULL, NULL},
    {1925, NULL, NULL},
    {1926, NULL, NULL},
    {1927, NULL, NULL},
    {1928, NULL, NULL},
    {1929, NULL, NULL},
    {1930, NULL, NULL},
    {1931, NULL, NULL},
    {1932, NULL, NULL},
    {1933, NULL, NULL},
    {1934, NULL, NULL},
    {1935, NULL, NULL},
    {1936, NULL, NULL},
    {1937, NULL, NULL},
    {1938, NULL, NULL},
    {1939, NULL, NULL},
    {1940, NULL, NULL},
    {1941, NULL, NULL},
    {1942, NULL, NULL},
    {1943, NULL, NULL},
    {1944, NULL, NULL},
    {1945, NULL, NULL},
    {1946, NULL, NULL},
    {1947, NULL, NULL},
    {1948, NULL, NULL},
    {1949, NULL, NULL},
    {1950, NULL, NULL},
    {1951, NULL, NULL},
    {1952, NULL, NULL},
    {1953, NULL, NULL},
    {1954, NULL, NULL},
    {1955, NULL, NULL},
    {1956, NULL, NULL},
    {1957, NULL, NULL},
    {1958, NULL, NULL},
    {1959, NULL, NULL},
    {1960, NULL, NULL},
    {1961, NULL, NULL},
    {1962, NULL, NULL},
    {1963, NULL, NULL},
    {1964, NULL, NULL},
    {1965, NULL, NULL},
    {1966, NULL, NULL},
    {1967, NULL, NULL},
    {1968, NULL, NULL},
    {1969, NULL, NULL},
    {1970, NULL, NULL},
    {1971, NULL, NULL},
    {1972, NULL, NULL},
    {1973, NULL, NULL},
    {1974, NULL, NULL},
    {1975, NULL, NULL},
    {1976, NULL, NULL},
    {1977, NULL, NULL},
    {1978, NULL, NULL},
    {1979, NULL, NULL},
    {1980, NULL, NULL},
    {1981, NULL, NULL},
    {1982, NULL, NULL},
    {1983, NULL, NULL},
    {1984, NULL, NULL},
    {1985, NULL, NULL},
    {1986, NULL, NULL},
    {1987, NULL, NULL},
    {1988, NULL, NULL},
    {1989, NULL, NULL},
    {1990, NULL, NULL},
    {1991, NULL, NULL},
    {1992, NULL, NULL},
    {1993, NULL, NULL},
    {1994, NULL, NULL},
    {1995, NULL, NULL},
    {1996, NULL, NULL},
    {1997, NULL, NULL},
    {1998, NULL, NULL},
    {1999, NULL, NULL},
    {2000, NULL, NULL},
    {2001, NULL, NULL},
    {2002, NULL, NULL},
    {2003, NULL, NULL},
    {2004, NULL, NULL},
    {2005, NULL, NULL},
    {2006, NULL, NULL},
    {2007, NULL, NULL},
    {2008, NULL, NULL},
    {2009, NULL, NULL},
    {2010, NULL, NULL},
    {2011, NULL, NULL},
    {2012, NULL, NULL},
    {2013, NULL, NULL},
    {2014, NULL, NULL},
    {2015, NULL, NULL},
    {2016, NULL, NULL},
    {2017, NULL, NULL},
    {2018, NULL, NULL},
    {2019, NULL, NULL},
    {2020, NULL, NULL},
    {2021, NULL, NULL},
    {2022, NULL, NULL},
    {2023, NULL, NULL},
    {2024, NULL, NULL},
    {2025, NULL, NULL},
    {2026, NULL, NULL},
    {2027, NULL, NULL},
    {2028, NULL, NULL},
    {2029, NULL, NULL},
    {2030, NULL, NULL},
    {2031, NULL, NULL},
    {2032, NULL, NULL},
    {2033, NULL, NULL},
    {2034, NULL, NULL},
    {2035, NULL, NULL},
    {2036, NULL, NULL},
    {2037, NULL, NULL},
    {2038, NULL, NULL},
    {2039, NULL, NULL},
    {2040, NULL, NULL},
    {2041, NULL, NULL},
    {2042, NULL, NULL},
    {2043, NULL, NULL},
    {2044, NULL, NULL},
    {2045, NULL, NULL},
    {2046, NULL, NULL},
    {2047, NULL, NULL},
    {2048, NULL, NULL},
    {2049, NULL, NULL},
    {2050, NULL, NULL},
    {2051, NULL, NULL},
    {2052, NULL, NULL},
    {2053, NULL, NULL},
    {2054, NULL, NULL},
    {2055, NULL, NULL},
    {2056, NULL, NULL},
    {2057, NULL, NULL},
    {2058, NULL, NULL},
    {2059, NULL, NULL},
    {2060, NULL, NULL},
    {2061, NULL, NULL},
    {2062, NULL, NULL},
    {2063, NULL, NULL},
    {2064, NULL, NULL},
    {2065, NULL, NULL},
    {2066, NULL, NULL},
    {2067, NULL, NULL},
    {2068, NULL, NULL},
    {2069, NULL, NULL},
    {2070, NULL, NULL},
    {2071, NULL, NULL},
    {2072, NULL, NULL},
    {2073, NULL, NULL},
    {2074, NULL, NULL},
    {2075, NULL, NULL},
    {2076, NULL, NULL},
    {2077, NULL, NULL},
    {2078, NULL, NULL},
    {2079, NULL, NULL},
    {2080, NULL, NULL},
    {2081, NULL, NULL},
    {2082, NULL, NULL},
    {2083, NULL, NULL},
    {2084, NULL, NULL},
    {2085, NULL, NULL},
    {2086, NULL, NULL},
    {2087, NULL, NULL},
    {2088, NULL, NULL},
    {2089, NULL, NULL},
    {2090, NULL, NULL},
    {2091, NULL, NULL},
    {2092, NULL, NULL},
    {2093, NULL, NULL},
    {2094, NULL, NULL},
    {2095, NULL, NULL},
    {2096, NULL, NULL},
    {2097, NULL, NULL},
    {2098, NULL, NULL},
    {2099, NULL, NULL},
    {2100, NULL, NULL},
    {2101, NULL, NULL},
    {2102, NULL, NULL},
    {2103, NULL, NULL},
    {2104, NULL, NULL},
    {2105, NULL, NULL},
    {2106, NULL, NULL},
    {2107, NULL, NULL},
    {2108, NULL, NULL},
    {2109, NULL, NULL},
    {2110, NULL, NULL},
    {2111, NULL, NULL},
    {2112, NULL, NULL},
    {2113, NULL, NULL},
    {2114, NULL, NULL},
    {2115, NULL, NULL},
    {2116, NULL, NULL},
    {2117, NULL, NULL},
    {2118, NULL, NULL},
    {2119, NULL, NULL},
    {2120, NULL, NULL},
    {2121, NULL, NULL},
    {2122, NULL, NULL},
    {2123, NULL, NULL},
    {2124, NULL, NULL},
    {2125, NULL, NULL},
    {2126, NULL, NULL},
    {2127, NULL, NULL},
    {2128, NULL, NULL},
    {2129, NULL, NULL},
    {2130, NULL, NULL},
    {2131, NULL, NULL},
    {2132, NULL, NULL},
    {2133, NULL, NULL},
    {2134, NULL, NULL},
    {2135, NULL, NULL},
    {2136, NULL, NULL},
    {2137, NULL, NULL},
    {2138, NULL, NULL},
    {2139, NULL, NULL},
    {2140, NULL, NULL},
    {2141, NULL, NULL},
    {2142, NULL, NULL},
    {2143, NULL, NULL},
    {2144, NULL, NULL},
    {2145, NULL, NULL},
    {2146, NULL, NULL},
    {2147, NULL, NULL},
    {2148, NULL, NULL},
    {2149, NULL, NULL},
    {2150, NULL, NULL},
    {2151, NULL, NULL},
    {2152, NULL, NULL},
    {2153, NULL, NULL},
    {2154, NULL, NULL},
    {2155, NULL, NULL},
    {2156, NULL, NULL},
    {2157, NULL, NULL},
    {2158, NULL, NULL},
    {2159, NULL, NULL},
    {2160, NULL, NULL},
    {2161, NULL, NULL},
    {2162, NULL, NULL},
    {2163, NULL, NULL},
    {2164, NULL, NULL},
    {2165, NULL, NULL},
    {2166, NULL, NULL},
    {2167, NULL, NULL},
    {2168, NULL, NULL},
    {2169, NULL, NULL},
    {2170, NULL, NULL},
    {2171, NULL, NULL},
    {2172, NULL, NULL},
    {2173, NULL, NULL},
    {2174, NULL, NULL},
    {2175, NULL, NULL},
    {2176, NULL, NULL},
    {2177, NULL, NULL},
    {2178, NULL, NULL},
    {2179, NULL, NULL},
    {2180, NULL, NULL},
    {2181, NULL, NULL},
    {2182, NULL, NULL},
    {2183, NULL, NULL},
    {2184, NULL, NULL},
    {2185, NULL, NULL},
    {2186, NULL, NULL},
    {2187, NULL, NULL},
    {2188, NULL, NULL},
    {2189, NULL, NULL},
    {2190, NULL, NULL},
    {2191, NULL, NULL},
    {2192, NULL, NULL},
    {2193, NULL, NULL},
    {2194, NULL, NULL},
    {2195, NULL, NULL},
    {2196, NULL, NULL},
    {2197, NULL, NULL},
    {2198, NULL, NULL},
    {2199, NULL, NULL},
    {2200, NULL, NULL},
    {2201, NULL, NULL},
    {2202, NULL, NULL},
    {2203, NULL, NULL},
    {2204, NULL, NULL},
    {2205, NULL, NULL},
    {2206, NULL, NULL},
    {2207, NULL, NULL},
    {2208, NULL, NULL},
    {2209, NULL, NULL},
    {2210, NULL, NULL},
    {2211, NULL, NULL},
    {2212, NULL, NULL},
    {2213, NULL, NULL},
    {2214, NULL, NULL},
    {2215, NULL, NULL},
    {2216, NULL, NULL},
    {2217, NULL, NULL},
    {2218, NULL, NULL},
    {2219, NULL, NULL},
    {2220, NULL, NULL},
    {2221, NULL, NULL},
    {2222, NULL, NULL},
    {2223, NULL, NULL},
    {2224, NULL, NULL},
    {2225, NULL, NULL},
    {2226, NULL, NULL},
    {2227, NULL, NULL},
    {2228, NULL, NULL},
    {2229, NULL, NULL},
    {2230, NULL, NULL},
    {2231, NULL, NULL},
    {2232, NULL, NULL},
    {2233, NULL, NULL},
    {2234, NULL, NULL},
    {2235, NULL, NULL},
    {2236, NULL, NULL},
    {2237, NULL, NULL},
    {2238, NULL, NULL},
    {2239, NULL, NULL},
    {2240, NULL, NULL},
    {2241, NULL, NULL},
    {2242, NULL, NULL},
    {2243, NULL, NULL},
    {2244, NULL, NULL},
    {2245, NULL, NULL},
    {2246, NULL, NULL},
    {2247, NULL, NULL},
    {2248, NULL, NULL},
    {2249, NULL, NULL},
    {2250, NULL, NULL},
    {2251, NULL, NULL},
    {2252, NULL, NULL},
    {2253, NULL, NULL},
    {2254, NULL, NULL},
    {2255, NULL, NULL},
    {2256, NULL, NULL},
    {2257, NULL, NULL},
    {2258, NULL, NULL},
    {2259, NULL, NULL},
    {2260, NULL, NULL},
    {2261, NULL, NULL},
    {2262, NULL, NULL},
    {2263, NULL, NULL},
    {2264, NULL, NULL},
    {2265, NULL, NULL},
    {2266, NULL, NULL},
    {2267, NULL, NULL},
    {2268, NULL, NULL},
    {2269, NULL, NULL},
    {2270, NULL, NULL},
    {2271, NULL, NULL},
    {2272, NULL, NULL},
    {2273, NULL, NULL},
    {2274, NULL, NULL},
    {2275, NULL, NULL},
    {2276, NULL, NULL},
    {2277, NULL, NULL},
    {2278, NULL, NULL},
    {2279, NULL, NULL},
    {2280, NULL, NULL},
    {2281, NULL, NULL},
    {2282, NULL, NULL},
    {2283, NULL, NULL},
    {2284, NULL, NULL},
    {2285, NULL, NULL},
    {2286, NULL, NULL},
    {2287, NULL, NULL},
    {2288, NULL, NULL},
    {2289, NULL, NULL},
    {2290, NULL, NULL},
    {2291, NULL, NULL},
    {2292, NULL, NULL},
    {2293, NULL, NULL},
    {2294, NULL, NULL},
    {2295, NULL, NULL},
    {2296, NULL, NULL},
    {2297, NULL, NULL},
    {2298, NULL, NULL},
    {2299, NULL, NULL},
    {2300, NULL, NULL},
    {2301, NULL, NULL},
    {2302, NULL, NULL},
    {2303, NULL, NULL},
    {2304, NULL, NULL},
    {2305, NULL, NULL},
    {2306, NULL, NULL},
    {2307, NULL, NULL},
    {2308, NULL, NULL},
    {2309, NULL, NULL},
    {2310, NULL, NULL},
    {2311, NULL, NULL},
    {2312, NULL, NULL},
    {2313, NULL, NULL},
    {2314, NULL, NULL},
    {2315, NULL, NULL},
    {2316, NULL, NULL},
    {2317, NULL, NULL},
    {2318, NULL, NULL},
    {2319, NULL, NULL},
    {2320, NULL, NULL},
    {2321, NULL, NULL},
    {2322, NULL, NULL},
    {2323, NULL, NULL},
    {2324, NULL, NULL},
    {2325, NULL, NULL},
    {2326, NULL, NULL},
    {2327, NULL, NULL},
    {2328, NULL, NULL},
    {2329, NULL, NULL},
    {2330, NULL, NULL},
    {2331, NULL, NULL},
    {2332, NULL, NULL},
    {2333, NULL, NULL},
    {2334, NULL, NULL},
    {2335, NULL, NULL},
    {2336, NULL, NULL},
    {2337, NULL, NULL},
    {2338, NULL, NULL},
    {2339, NULL, NULL},
    {2340, NULL, NULL},
    {2341, NULL, NULL},
    {2342, NULL, NULL},
    {2343, NULL, NULL},
    {2344, NULL, NULL},
    {2345, NULL, NULL},
    {2346, NULL, NULL},
    {2347, NULL, NULL},
    {2348, NULL, NULL},
    {2349, NULL, NULL},
    {2350, NULL, NULL},
    {2351, NULL, NULL},
    {2352, NULL, NULL},
    {2353, NULL, NULL},
    {2354, NULL, NULL},
    {2355, NULL, NULL},
    {2356, NULL, NULL},
    {2357, NULL, NULL},
    {2358, NULL, NULL},
    {2359, NULL, NULL},
    {2360, NULL, NULL},
    {2361, NULL, NULL},
    {2362, NULL, NULL},
    {2363, NULL, NULL},
    {2364, NULL, NULL},
    {2365, NULL, NULL},
    {2366, NULL, NULL},
    {2367, NULL, NULL},
    {2368, NULL, NULL},
    {2369, NULL, NULL},
    {2370, NULL, NULL},
    {2371, NULL, NULL},
    {2372, NULL, NULL},
    {2373, NULL, NULL},
    {2374, NULL, NULL},
    {2375, NULL, NULL},
    {2376, NULL, NULL},
    {2377, NULL, NULL},
    {2378, NULL, NULL},
    {2379, NULL, NULL},
    {2380, NULL, NULL},
    {2381, NULL, NULL},
    {2382, NULL, NULL},
    {2383, NULL, NULL},
    {2384, NULL, NULL},
    {2385, NULL, NULL},
    {2386, NULL, NULL},
    {2387, NULL, NULL},
    {2388, NULL, NULL},
    {2389, NULL, NULL},
    {2390, NULL, NULL},
    {2391, NULL, NULL},
    {2392, NULL, NULL},
    {2393, NULL, NULL},
    {2394, NULL, NULL},
    {2395, NULL, NULL},
    {2396, NULL, NULL},
    {2397, NULL, NULL},
    {2398, NULL, NULL},
    {2399, NULL, NULL},
    {2400, NULL, NULL},
    {2401, NULL, NULL},
    {2402, NULL, NULL},
    {2403, NULL, NULL},
    {2404, NULL, NULL},
    {2405, NULL, NULL},
    {2406, NULL, NULL},
    {2407, NULL, NULL},
    {2408, NULL, NULL},
    {2409, NULL, NULL},
    {2410, NULL, NULL},
    {2411, NULL, NULL},
    {2412, NULL, NULL},
    {2413, NULL, NULL},
    {2414, NULL, NULL},
    {2415, NULL, NULL},
    {2416, NULL, NULL},
    {2417, NULL, NULL},
    {2418, NULL, NULL},
    {2419, NULL, NULL},
    {2420, NULL, NULL},
    {2421, NULL, NULL},
    {2422, NULL, NULL},
    {2423, NULL, NULL},
    {2424, NULL, NULL},
    {2425, NULL, NULL},
    {2426, NULL, NULL},
    {2427, NULL, NULL},
    {2428, NULL, NULL},
    {2429, NULL, NULL},
    {2430, NULL, NULL},
    {2431, NULL, NULL},
    {2432, NULL, NULL},
    {2433, NULL, NULL},
    {2434, NULL, NULL},
    {2435, NULL, NULL},
    {2436, NULL, NULL},
    {2437, NULL, NULL},
    {2438, NULL, NULL},
    {2439, NULL, NULL},
    {2440, NULL, NULL},
    {2441, NULL, NULL},
    {2442, NULL, NULL},
    {2443, NULL, NULL},
    {2444, NULL, NULL},
    {2445, NULL, NULL},
    {2446, NULL, NULL},
    {2447, NULL, NULL},
    {2448, NULL, NULL},
    {2449, NULL, NULL},
    {2450, NULL, NULL},
    {2451, NULL, NULL},
    {2452, NULL, NULL},
    {2453, NULL, NULL},
    {2454, NULL, NULL},
    {2455, NULL, NULL},
    {2456, NULL, NULL},
    {2457, NULL, NULL},
    {2458, NULL, NULL},
    {2459, NULL, NULL},
    {2460, NULL, NULL},
    {2461, NULL, NULL},
    {2462, NULL, NULL},
    {2463, NULL, NULL},
    {2464, NULL, NULL},
    {2465, NULL, NULL},
    {2466, NULL, NULL},
    {2467, NULL, NULL},
    {2468, NULL, NULL},
    {2469, NULL, NULL},
    {2470, NULL, NULL},
    {2471, NULL, NULL},
    {2472, NULL, NULL},
    {2473, NULL, NULL},
    {2474, NULL, NULL},
    {2475, NULL, NULL},
    {2476, NULL, NULL},
    {2477, NULL, NULL},
    {2478, NULL, NULL},
    {2479, NULL, NULL},
    {2480, NULL, NULL},
    {2481, NULL, NULL},
    {2482, NULL, NULL},
    {2483, NULL, NULL},
    {2484, NULL, NULL},
    {2485, NULL, NULL},
    {2486, NULL, NULL},
    {2487, NULL, NULL},
    {2488, NULL, NULL},
    {2489, NULL, NULL},
    {2490, NULL, NULL},
    {2491, NULL, NULL},
    {2492, NULL, NULL},
    {2493, NULL, NULL},
    {2494, NULL, NULL},
    {2495, NULL, NULL},
    {2496, NULL, NULL},
    {2497, NULL, NULL},
    {2498, NULL, NULL},
    {2499, NULL, NULL},
    {2500, NULL, NULL},
    {2501, NULL, NULL},
    {2502, NULL, NULL},
    {2503, NULL, NULL},
    {2504, NULL, NULL},
    {2505, NULL, NULL},
    {2506, NULL, NULL},
    {2507, NULL, NULL},
    {2508, NULL, NULL},
    {2509, NULL, NULL},
    {2510, NULL, NULL},
    {2511, NULL, NULL},
    {2512, NULL, NULL},
    {2513, NULL, NULL},
    {2514, NULL, NULL},
    {2515, NULL, NULL},
    {2516, NULL, NULL},
    {2517, NULL, NULL},
    {2518, NULL, NULL},
    {2519, NULL, NULL},
    {2520, NULL, NULL},
    {2521, NULL, NULL},
    {2522, NULL, NULL},
    {2523, NULL, NULL},
    {2524, NULL, NULL},
    {2525, NULL, NULL},
    {2526, NULL, NULL},
    {2527, NULL, NULL},
    {2528, NULL, NULL},
    {2529, NULL, NULL},
    {2530, NULL, NULL},
    {2531, NULL, NULL},
    {2532, NULL, NULL},
    {2533, NULL, NULL},
    {2534, NULL, NULL},
    {2535, NULL, NULL},
    {2536, NULL, NULL},
    {2537, NULL, NULL},
    {2538, NULL, NULL},
    {2539, NULL, NULL},
    {2540, NULL, NULL},
    {2541, NULL, NULL},
    {2542, NULL, NULL},
    {2543, NULL, NULL},
    {2544, NULL, NULL},
    {2545, NULL, NULL},
    {2546, NULL, NULL},
    {2547, NULL, NULL},
    {2548, NULL, NULL},
    {2549, NULL, NULL},
    {2550, NULL, NULL},
    {2551, NULL, NULL},
    {2552, NULL, NULL},
    {2553, NULL, NULL},
    {2554, NULL, NULL},
    {2555, NULL, NULL},
    {2556, NULL, NULL},
    {2557, NULL, NULL},
    {2558, NULL, NULL},
    {2559, NULL, NULL},
    {2560, NULL, NULL},
    {2561, NULL, NULL},
    {2562, NULL, NULL},
    {2563, NULL, NULL},
    {2564, NULL, NULL},
    {2565, NULL, NULL},
    {2566, NULL, NULL},
    {2567, NULL, NULL},
    {2568, NULL, NULL},
    {2569, NULL, NULL},
    {2570, NULL, NULL},
    {2571, NULL, NULL},
    {2572, NULL, NULL},
    {2573, NULL, NULL},
    {2574, NULL, NULL},
    {2575, NULL, NULL},
    {2576, NULL, NULL},
    {2577, NULL, NULL},
    {2578, NULL, NULL},
    {2579, NULL, NULL},
    {2580, NULL, NULL},
    {2581, NULL, NULL},
    {2582, NULL, NULL},
    {2583, NULL, NULL},
    {2584, NULL, NULL},
    {2585, NULL, NULL},
    {2586, NULL, NULL},
    {2587, NULL, NULL},
    {2588, NULL, NULL},
    {2589, NULL, NULL},
    {2590, NULL, NULL},
    {2591, NULL, NULL},
    {2592, NULL, NULL},
    {2593, NULL, NULL},
    {2594, NULL, NULL},
    {2595, NULL, NULL},
    {2596, NULL, NULL},
    {2597, NULL, NULL},
    {2598, NULL, NULL},
    {2599, NULL, NULL},
    {2600, NULL, NULL},
    {2601, NULL, NULL},
    {2602, NULL, NULL},
    {2603, NULL, NULL},
    {2604, NULL, NULL},
    {2605, NULL, NULL},
    {2606, NULL, NULL},
    {2607, NULL, NULL},
    {2608, NULL, NULL},
    {2609, NULL, NULL},
    {2610, NULL, NULL},
    {2611, NULL, NULL},
    {2612, NULL, NULL},
    {2613, NULL, NULL},
    {2614, NULL, NULL},
    {2615, NULL, NULL},
    {2616, NULL, NULL},
    {2617, NULL, NULL},
    {2618, NULL, NULL},
    {2619, NULL, NULL},
    {2620, NULL, NULL},
    {2621, NULL, NULL},
    {2622, NULL, NULL},
    {2623, NULL, NULL},
    {2624, NULL, NULL},
    {2625, NULL, NULL},
    {2626, NULL, NULL},
    {2627, NULL, NULL},
    {2628, NULL, NULL},
    {2629, NULL, NULL},
    {2630, NULL, NULL},
    {2631, NULL, NULL},
    {2632, NULL, NULL},
    {2633, NULL, NULL},
    {2634, NULL, NULL},
    {2635, NULL, NULL},
    {2636, NULL, NULL},
    {2637, NULL, NULL},
    {2638, NULL, NULL},
    {2639, NULL, NULL},
    {2640, NULL, NULL},
    {2641, NULL, NULL},
    {2642, NULL, NULL},
    {2643, NULL, NULL},
    {2644, NULL, NULL},
    {2645, NULL, NULL},
    {2646, NULL, NULL},
    {2647, NULL, NULL},
    {2648, NULL, NULL},
    {2649, NULL, NULL},
    {2650, NULL, NULL},
    {2651, NULL, NULL},
    {2652, NULL, NULL},
    {2653, NULL, NULL},
    {2654, NULL, NULL},
    {2655, NULL, NULL},
    {2656, NULL, NULL},
    {2657, NULL, NULL},
    {2658, NULL, NULL},
    {2659, NULL, NULL},
    {2660, NULL, NULL},
    {2661, NULL, NULL},
    {2662, NULL, NULL},
    {2663, NULL, NULL},
    {2664, NULL, NULL},
    {2665, NULL, NULL},
    {2666, NULL, NULL},
    {2667, NULL, NULL},
    {2668, NULL, NULL},
    {2669, NULL, NULL},
    {2670, NULL, NULL},
    {2671, NULL, NULL},
    {2672, NULL, NULL},
    {2673, NULL, NULL},
    {2674, NULL, NULL},
    {2675, NULL, NULL},
    {2676, NULL, NULL},
    {2677, NULL, NULL},
    {2678, NULL, NULL},
    {2679, NULL, NULL},
    {2680, NULL, NULL},
    {2681, NULL, NULL},
    {2682, NULL, NULL},
    {2683, NULL, NULL},
    {2684, NULL, NULL},
    {2685, NULL, NULL},
    {2686, NULL, NULL},
    {2687, NULL, NULL},
    {2688, NULL, NULL},
    {2689, NULL, NULL},
    {2690, NULL, NULL},
    {2691, NULL, NULL},
    {2692, NULL, NULL},
    {2693, NULL, NULL},
    {2694, NULL, NULL},
    {2695, NULL, NULL},
    {2696, NULL, NULL},
    {2697, NULL, NULL},
    {2698, NULL, NULL},
    {2699, NULL, NULL},
    {2700, NULL, NULL},
    {2701, NULL, NULL},
    {2702, NULL, NULL},
    {2703, NULL, NULL},
    {2704, NULL, NULL},
    {2705, NULL, NULL},
    {2706, NULL, NULL},
    {2707, NULL, NULL},
    {2708, NULL, NULL},
    {2709, NULL, NULL},
    {2710, NULL, NULL},
    {2711, NULL, NULL},
    {2712, NULL, NULL},
    {2713, NULL, NULL},
    {2714, NULL, NULL},
    {2715, NULL, NULL},
    {2716, NULL, NULL},
    {2717, NULL, NULL},
    {2718, NULL, NULL},
    {2719, NULL, NULL},
    {2720, NULL, NULL},
    {2721, NULL, NULL},
    {2722, NULL, NULL},
    {2723, NULL, NULL},
    {2724, NULL, NULL},
    {2725, NULL, NULL},
    {2726, NULL, NULL},
    {2727, NULL, NULL},
    {2728, NULL, NULL},
    {2729, NULL, NULL},
    {2730, NULL, NULL},
    {2731, NULL, NULL},
    {2732, NULL, NULL},
    {2733, NULL, NULL},
    {2734, NULL, NULL},
    {2735, NULL, NULL},
    {2736, NULL, NULL},
    {2737, NULL, NULL},
    {2738, NULL, NULL},
    {2739, NULL, NULL},
    {2740, NULL, NULL},
    {2741, NULL, NULL},
    {2742, NULL, NULL},
    {2743, NULL, NULL},
    {2744, NULL, NULL},
    {2745, NULL, NULL},
    {2746, NULL, NULL},
    {2747, NULL, NULL},
    {2748, NULL, NULL},
    {2749, NULL, NULL},
    {2750, NULL, NULL},
    {2751, NULL, NULL},
    {2752, NULL, NULL},
    {2753, NULL, NULL},
    {2754, NULL, NULL},
    {2755, NULL, NULL},
    {2756, NULL, NULL},
    {2757, NULL, NULL},
    {2758, NULL, NULL},
    {2759, NULL, NULL},
    {2760, NULL, NULL},
    {2761, NULL, NULL},
    {2762, NULL, NULL},
    {2763, NULL, NULL},
    {2764, NULL, NULL},
    {2765, NULL, NULL},
    {2766, NULL, NULL},
    {2767, NULL, NULL},
    {2768, NULL, NULL},
    {2769, NULL, NULL},
    {2770, NULL, NULL},
    {2771, NULL, NULL},
    {2772, NULL, NULL},
    {2773, NULL, NULL},
    {2774, NULL, NULL},
    {2775, NULL, NULL},
    {2776, NULL, NULL},
    {2777, NULL, NULL},
    {2778, NULL, NULL},
    {2779, NULL, NULL},
    {2780, NULL, NULL},
    {2781, NULL, NULL},
    {2782, NULL, NULL},
    {2783, NULL, NULL},
    {2784, NULL, NULL},
    {2785, NULL, NULL},
    {2786, NULL, NULL},
    {2787, NULL, NULL},
    {2788, NULL, NULL},
    {2789, NULL, NULL},
    {2790, NULL, NULL},
    {2791, NULL, NULL},
    {2792, NULL, NULL},
    {2793, NULL, NULL},
    {2794, NULL, NULL},
    {2795, NULL, NULL},
    {2796, NULL, NULL},
    {2797, NULL, NULL},
    {2798, NULL, NULL},
    {2799, NULL, NULL},
    {2800, NULL, NULL},
    {2801, NULL, NULL},
    {2802, NULL, NULL},
    {2803, NULL, NULL},
    {2804, NULL, NULL},
    {2805, NULL, NULL},
    {2806, NULL, NULL},
    {2807, NULL, NULL},
    {2808, NULL, NULL},
    {2809, NULL, NULL},
    {2810, NULL, NULL},
    {2811, NULL, NULL},
    {2812, NULL, NULL},
    {2813, NULL, NULL},
    {2814, NULL, NULL},
    {2815, NULL, NULL},
    {2816, NULL, NULL},
    {2817, NULL, NULL},
    {2818, NULL, NULL},
    {2819, NULL, NULL},
    {2820, NULL, NULL},
    {2821, NULL, NULL},
    {2822, NULL, NULL},
    {2823, NULL, NULL},
    {2824, NULL, NULL},
    {2825, NULL, NULL},
    {2826, NULL, NULL},
    {2827, NULL, NULL},
    {2828, NULL, NULL},
    {2829, NULL, NULL},
    {2830, NULL, NULL},
    {2831, NULL, NULL},
    {2832, NULL, NULL},
    {2833, NULL, NULL},
    {2834, NULL, NULL},
    {2835, NULL, NULL},
    {2836, NULL, NULL},
    {2837, NULL, NULL},
    {2838, NULL, NULL},
    {2839, NULL, NULL},
    {2840, NULL, NULL},
    {2841, NULL, NULL},
    {2842, NULL, NULL},
    {2843, NULL, NULL},
    {2844, NULL, NULL},
    {2845, NULL, NULL},
    {2846, NULL, NULL},
    {2847, NULL, NULL},
    {2848, NULL, NULL},
    {2849, NULL, NULL},
    {2850, NULL, NULL},
    {2851, NULL, NULL},
    {2852, NULL, NULL},
    {2853, NULL, NULL},
    {2854, NULL, NULL},
    {2855, NULL, NULL},
    {2856, NULL, NULL},
    {2857, NULL, NULL},
    {2858, NULL, NULL},
    {2859, NULL, NULL},
    {2860, NULL, NULL},
    {2861, NULL, NULL},
    {2862, NULL, NULL},
    {2863, NULL, NULL},
    {2864, NULL, NULL},
    {2865, NULL, NULL},
    {2866, NULL, NULL},
    {2867, NULL, NULL},
    {2868, NULL, NULL},
    {2869, NULL, NULL},
    {2870, NULL, NULL},
    {2871, NULL, NULL},
    {2872, NULL, NULL},
    {2873, NULL, NULL},
    {2874, NULL, NULL},
    {2875, NULL, NULL},
    {2876, NULL, NULL},
    {2877, NULL, NULL},
    {2878, NULL, NULL},
    {2879, NULL, NULL},
    {2880, NULL, NULL},
    {2881, NULL, NULL},
    {2882, NULL, NULL},
    {2883, NULL, NULL},
    {2884, NULL, NULL},
    {2885, NULL, NULL},
    {2886, NULL, NULL},
    {2887, NULL, NULL},
    {2888, NULL, NULL},
    {2889, NULL, NULL},
    {2890, NULL, NULL},
    {2891, NULL, NULL},
    {2892, NULL, NULL},
    {2893, NULL, NULL},
    {2894, NULL, NULL},
    {2895, NULL, NULL},
    {2896, NULL, NULL},
    {2897, NULL, NULL},
    {2898, NULL, NULL},
    {2899, NULL, NULL},
    {2900, NULL, NULL},
    {2901, NULL, NULL},
    {2902, NULL, NULL},
    {2903, NULL, NULL},
    {2904, NULL, NULL},
    {2905, NULL, NULL},
    {2906, NULL, NULL},
    {2907, NULL, NULL},
    {2908, NULL, NULL},
    {2909, NULL, NULL},
    {2910, NULL, NULL},
    {2911, NULL, NULL},
    {2912, NULL, NULL},
    {2913, NULL, NULL},
    {2914, NULL, NULL},
    {2915, NULL, NULL},
    {2916, NULL, NULL},
    {2917, NULL, NULL},
    {2918, NULL, NULL},
    {2919, NULL, NULL},
    {2920, NULL, NULL},
    {2921, NULL, NULL},
    {2922, NULL, NULL},
    {2923, NULL, NULL},
    {2924, NULL, NULL},
    {2925, NULL, NULL},
    {2926, NULL, NULL},
    {2927, NULL, NULL},
    {2928, NULL, NULL},
    {2929, NULL, NULL},
    {2930, NULL, NULL},
    {2931, NULL, NULL},
    {2932, NULL, NULL},
    {2933, NULL, NULL},
    {2934, NULL, NULL},
    {2935, NULL, NULL},
    {2936, NULL, NULL},
    {2937, NULL, NULL},
    {2938, NULL, NULL},
    {2939, NULL, NULL},
    {2940, NULL, NULL},
    {2941, NULL, NULL},
    {2942, NULL, NULL},
    {2943, NULL, NULL},
    {2944, NULL, NULL},
    {2945, NULL, NULL},
    {2946, NULL, NULL},
    {2947, NULL, NULL},
    {2948, NULL, NULL},
    {2949, NULL, NULL},
    {2950, NULL, NULL},
    {2951, NULL, NULL},
    {2952, NULL, NULL},
    {2953, NULL, NULL},
    {2954, NULL, NULL},
    {2955, NULL, NULL},
    {2956, NULL, NULL},
    {2957, NULL, NULL},
    {2958, NULL, NULL},
    {2959, NULL, NULL},
    {2960, NULL, NULL},
    {2961, NULL, NULL},
    {2962, NULL, NULL},
    {2963, NULL, NULL},
    {2964, NULL, NULL},
    {2965, NULL, NULL},
    {2966, NULL, NULL},
    {2967, NULL, NULL},
    {2968, NULL, NULL},
    {2969, NULL, NULL},
    {2970, NULL, NULL},
    {2971, NULL, NULL},
    {2972, NULL, NULL},
    {2973, NULL, NULL},
    {2974, NULL, NULL},
    {2975, NULL, NULL},
    {2976, NULL, NULL},
    {2977, NULL, NULL},
    {2978, NULL, NULL},
    {2979, NULL, NULL},
    {2980, NULL, NULL},
    {2981, NULL, NULL},
    {2982, NULL, NULL},
    {2983, NULL, NULL},
    {2984, NULL, NULL},
    {2985, NULL, NULL},
    {2986, NULL, NULL},
    {2987, NULL, NULL},
    {2988, NULL, NULL},
    {2989, NULL, NULL},
    {2990, NULL, NULL},
    {2991, NULL, NULL},
    {2992, NULL, NULL},
    {2993, NULL, NULL},
    {2994, NULL, NULL},
    {2995, NULL, NULL},
    {2996, NULL, NULL},
    {2997, NULL, NULL},
    {2998, NULL, NULL},
    {2999, NULL, NULL},
    {3000, "HY000", "File  is corrupted"},
    {3001, "HY000", "Query partially completed on the master (error on master: ) and was aborted. There is a chance that your master is inconsistent at this point. If you are sure that your master is ok, run this query manually on the slave and then restart the slave with SET GLOBAL SQL_SLAVE_SKIP_COUNTER=1; START SLAVE;. Query:''"},
    {3002, "HY000", "Query caused different errors on master and slave. Error on master: message (format)='' error code=; Error on slave:actual message='', error code=. Default database:''. Query:''"},
    {3003, "HY000", "Storage engine for table ''.'' is not loaded."},
    {3004, "0Z002", "GET STACKED DIAGNOSTICS when handler not active"},
    {3005, "HY000", " is no longer supported. The statement was converted to ."},
    {3006, "HY000", "Statement is unsafe because it uses a fulltext parser plugin which may not return the same value on the slave."},
    {3007, "HY000", "Cannot DISCARD/IMPORT tablespace associated with temporary table"},
    {3008, "HY000", "Foreign key cascade delete/update exceeds max depth of ."},
    {3009, "HY000", "Column count of . is wrong. Expected , found . Created with MySQL , now running . Please use mysql_upgrade to fix this error."},
    {3010, "HY000", "Trigger .. does not have CREATED attribute."},
    {3011, "HY000", "Referenced trigger '' for the given action time and event type does not exist."},
    {3012, "HY000", "EXPLAIN FOR CONNECTION command is supported only for SELECT/UPDATE/INSERT/DELETE/REPLACE"},
    {3013, "HY000", "Invalid size for column ''."},
    {3014, "HY000", "Table storage engine '' found required create option missing"},
    {3015, "HY000", "Out of memory in storage engine ''."},
    {3016, "HY000", "The password for anonymous user cannot be expired."},
    {3017, "HY000", "This operation cannot be performed with a running slave sql thread; run STOP SLAVE SQL_THREAD first"},
    {3018, "HY000", "Cannot create FULLTEXT index on materialized subquery"},
    {3019, "HY000", "Undo Log error: "},
    {3020, "2201E", "Invalid argument for logarithm"},
    {3021, "HY000", "This operation cannot be performed with a running slave io thread; run STOP SLAVE IO_THREAD FOR CHANNEL '' first."},
    {3022, "HY000", "This operation may not be safe when the slave has temporary tables. The tables will be kept open until the server restarts or until the tables are deleted by any replicated DROP statement. Suggest to wait until slave_open_temp_tables = 0."},
    {3023, "HY000", "CHANGE MASTER TO with a MASTER_LOG_FILE clause but no MASTER_LOG_POS clause may not be safe. The old position value may not be valid for the new binary log file."},
    {3024, "HY000", "Query execution was interrupted, maximum statement execution time exceeded"},
    {3025, "HY000", "Select is not a read only statement, disabling timer"},
    {3026, "HY000", "Duplicate entry ''."},
    {3027, "HY000", "'' mode no longer has any effect. Use STRICT_ALL_TABLES or STRICT_TRANS_TABLES instead."},
    {3028, "HY000", "Expression # of ORDER BY contains aggregate function and applies to a UNION"},
    {3029, "HY000", "Expression # of ORDER BY contains aggregate function and applies to the result of a non-aggregated query"},
    {3030, "HY000", "Slave worker has stopped after at least one previous worker encountered an error when slave-preserve-commit-order was enabled. To preserve commit order, the last transaction executed by this thread has not been committed. When restarting the slave after fixing any failed threads, you should fix this worker as well."},
    {3031, "HY000", "slave_preserve_commit_order is not supported ."},
    {3032, "HY000", "The server is currently in offline mode"},
    {3033, "HY000", "Binary geometry function  given two geometries of different srids:  and , which should have been identical."},
    {3034, "HY000", "Calling geometry function  with unsupported types of arguments."},
    {3035, "HY000", "Unknown GIS error occured in function ."},
    {3036, "HY000", "Unknown exception caught in GIS function ."},
    {3037, "22023", "Invalid GIS data provided to function ."},
    {3038, "HY000", "The geometry has no data in function ."},
    {3039, "HY000", "Unable to calculate centroid because geometry is empty in function ."},
    {3040, "HY000", "Geometry overlay calculation error: geometry data is invalid in function ."},
    {3041, "HY000", "Geometry turn info calculation error: geometry data is invalid in function ."},
    {3042, "HY000", "Analysis procedures of intersection points interrupted unexpectedly in function ."},
    {3043, "HY000", "Unknown exception thrown in function ."},
    {3044, "HY000", "Memory allocation error:  in function ."},
    {3045, "HY000", "Domain error:  in function ."},
    {3046, "HY000", "Length error:  in function ."},
    {3047, "HY000", "Invalid argument error:  in function ."},
    {3048, "HY000", "Out of range error:  in function ."},
    {3049, "HY000", "Overflow error error:  in function ."},
    {3050, "HY000", "Range error:  in function ."},
    {3051, "HY000", "Underflow error:  in function ."},
    {3052, "HY000", "Logic error:  in function ."},
    {3053, "HY000", "Runtime error:  in function ."},
    {3054, "HY000", "Unknown exception:  in function ."},
    {3055, "HY000", "Geometry byte string must be little endian."},
    {3056, "HY000", "The password provided for the replication user exceeds the maximum length of 32 characters"},
    {3057, "42000", "Incorrect user-level lock name ''."},
    {3058, "HY000", "Deadlock found when trying to get user-level lock; try rolling back transaction/releasing locks and restarting lock acquisition."},
    {3059, "HY000", "REPLACE cannot be executed as it requires deleting rows that are not in the view"},
    {3060, "HY000", "Do not support online operation on table with GIS index"},
    {3061, "42000", "User variable name '' is illegal"},
    {3062, "HY000", "Cannot  when GTID_MODE = OFF."},
    {3063, "HY000", "Cannot  from a replication slave thread."},
    {3064, "HY000", "Incorrect type for argument  in function ."},
    {3065, "HY000", "Expression # of ORDER BY clause is not in SELECT list, references column '' which is not in SELECT list; this is incompatible with "},
    {3066, "HY000", "Expression # of ORDER BY clause is not in SELECT list, contains aggregate function; this is incompatible with "},
    {3067, "HY000", "Supplied filter list contains a value which is not in the required format 'db_pattern.table_pattern'"},
    {3068, "08S01", "OK packet too large"},
    {3069, "HY000", "Invalid JSON data provided to function : "},
    {3070, "HY000", "Invalid GeoJSON data provided to function : Missing required member ''"},
    {3071, "HY000", "Invalid GeoJSON data provided to function : Member '' must be of type ''"},
    {3072, "HY000", "Invalid GeoJSON data provided to function "},
    {3073, "HY000", "Unsupported number of coordinate dimensions in function : Found , expected "},
    {3074, "HY000", "Slave channel '' does not exist."},
    {3075, "HY000", "A slave channel '' already exists for the given host and port combination."},
    {3076, "HY000", "Couldn't create channel: Channel name is either invalid or too long."},
    {3077, "HY000", "To have multiple channels, repository cannot be of type FILE; Please check the repository configuration and convert them to TABLE."},
    {3078, "HY000", "Cannot delete slave info objects for channel ''."},
    {3079, "HY000", "Multiple channels exist on the slave. Please provide channel name as an argument."},
    {3080, "HY000", "Maximum number of replication channels allowed exceeded."},
    {3081, "HY000", "This operation cannot be performed with running replication threads; run STOP SLAVE FOR CHANNEL '' first"},
    {3082, "HY000", "This operation requires running replication threads; configure slave and run START SLAVE FOR CHANNEL ''"},
    {3083, "HY000", "Replication thread(s) for channel '' are already runnning."},
    {3084, "HY000", "Replication thread(s) for channel '' are already stopped."},
    {3085, "HY000", "This operation cannot be performed with a running slave sql thread; run STOP SLAVE SQL_THREAD FOR CHANNEL '' first."},
    {3086, "HY000", "When sql_slave_skip_counter > 0, it is not allowed to start more than one SQL thread by using 'START SLAVE [SQL_THREAD]'. Value of sql_slave_skip_counter can only be used by one SQL thread at a time. Please use 'START SLAVE [SQL_THREAD] FOR CHANNEL' to start the SQL thread which will use the value of sql_slave_skip_counter."},
    {3087, "HY000", "Expression # of  is not in GROUP BY clause and contains nonaggregated column '' which is not functionally dependent on columns in GROUP BY clause; this is incompatible with sql_mode=only_full_group_by"},
    {3088, "HY000", "In aggregated query without GROUP BY, expression # of  contains nonaggregated column ''; this is incompatible with sql_mode=only_full_group_by"},
    {3089, "HY000", "Updating '' is deprecated. It will be made read-only in a future release."},
    {3090, "HY000", "Changing sql mode '' is deprecated. It will be removed in a future release."},
    {3091, "HY000", "DROP DATABASE failed; some tables may have been dropped but the database directory remains. The GTID has not been added to GTID_EXECUTED and the statement was not written to the binary log. Fix this as follows: (1) remove all files from the database directory ; (2) SET GTID_NEXT=''; (3) DROP DATABASE ``."},
    {3092, "HY000", "The server is not configured properly to be an active member of the group. Please see more details on error log."},
    {3093, "HY000", "The START GROUP_REPLICATION command failed since the group is already running."},
    {3094, "HY000", "The START GROUP_REPLICATION command failed as the applier module failed to start."},
    {3095, "HY000", "The STOP GROUP_REPLICATION command execution is incomplete: The applier thread got the stop signal while it was busy. The applier thread will stop once the current task is complete."},
    {3096, "HY000", "The START GROUP_REPLICATION command failed as there was an error when initializing the group communication layer."},
    {3097, "HY000", "The START GROUP_REPLICATION command failed as there was an error when joining the communication group."},
    {3098, "HY000", "The table does not comply with the requirements by an external plugin."},
    {3099, "HY000", "Cannot change the value of variable  without binary log format as ROW."},
    {3100, "HY000", "Error on observer while running replication hook ''."},
    {3101, "HY000", "Plugin instructed the server to rollback the current transaction."},
    {3102, "HY000", "Expression of generated column '' contains a disallowed function."},
    {3103, "HY000", "Key/Index cannot be defined on a virtual generated column."},
    {3104, "HY000", "Cannot define foreign key with  clause on a generated column."},
    {3105, "HY000", "The value specified for generated column '' in table '' is not allowed."},
    {3106, "HY000", "'' is not supported for generated columns."},
    {3107, "HY000", "Generated column can refer only to generated columns defined prior to it."},
    {3108, "HY000", "Column '' has a generated column dependency."},
    {3109, "HY000", "Generated column '' cannot refer to auto-increment column."},
    {3110, "HY000", "The '' feature is not available; you need to remove '' or use MySQL built with ''"},
    {3111, "HY000", "SET @@GLOBAL.GTID_MODE =  is not allowed because ."},
    {3112, "HY000", "The replication receiver thread cannot start in AUTO_POSITION mode: this server uses @@GLOBAL.GTID_MODE = OFF."},
    {3113, "HY000", "Cannot replicate anonymous transaction when AUTO_POSITION = 1, at file , position ."},
    {3114, "HY000", "Cannot replicate anonymous transaction when @@GLOBAL.GTID_MODE = ON, at file , position ."},
    {3115, "HY000", "Cannot replicate GTID-transaction when @@GLOBAL.GTID_MODE = OFF, at file , position ."},
    {3116, "HY000", "Cannot set ENFORCE_GTID_CONSISTENCY = ON because there are ongoing transactions that violate GTID consistency."},
    {3117, "HY000", "There are ongoing transactions that violate GTID consistency."},
    {3118, "HY000", "Access denied for user ''@''. Account is locked."},
    {3119, "42000", "Incorrect tablespace name ``"},
    {3120, "HY000", "Tablespace `` is not empty."},
    {3121, "HY000", "Incorrect File Name ''."},
    {3122, "HY000", "Inconsistent intersection points."},
    {3123, "HY000", "Optimizer hint syntax error"},
    {3124, "HY000", "Unsupported MAX_EXECUTION_TIME"},
    {3125, "HY000", "MAX_EXECUTION_TIME hint is supported by top-level standalone SELECT statements only"},
    {3126, "HY000", "Hint  is ignored as conflicting/duplicated"},
    {3127, "HY000", "Query block name  is not found for  hint"},
    {3128, "HY000", "Unresolved name  for  hint"},
    {3129, "HY000", "Unsetting sql mode '' is deprecated. It will be made read-only in a future release."},
    {3130, "HY000", "Command not supported by pluggable protocols"},
    {3131, "42000", "Incorrect locking service lock name ''."},
    {3132, "HY000", "Deadlock found when trying to get locking service lock; try releasing locks and restarting lock acquisition."},
    {3133, "HY000", "Service lock wait timeout exceeded."},
    {3134, "HY000", "Parameter  exceeds the maximum number of points in a geometry () in function ."},
    {3135, "HY000", "'NO_ZERO_DATE', 'NO_ZERO_IN_DATE' and 'ERROR_FOR_DIVISION_BY_ZERO' sql modes should be used with strict mode. They will be merged with strict mode in a future release."},
    {3136, "HY000", "Version token mismatch for . Correct value "},
    {3137, "HY000", "Version token not found."},
    {3138, "HY000", "Variable  cannot be changed by a client that owns a GTID. The client owns . Ownership is released on COMMIT or ROLLBACK."},
    {3139, "HY000", " cannot be performed on channel ''."},
    {3140, "22032", "Invalid JSON text: "" at position  in value for column ''."},
    {3141, "22032", "Invalid JSON text in argument  to function : "" at position ."},
    {3142, "HY000", "The JSON binary value contains invalid data."},
    {3143, "42000", "Invalid JSON path expression. The error is around character position ."},
    {3144, "22032", "Cannot create a JSON value from a string with CHARACTER SET ''."},
    {3145, "22032", "Invalid JSON character data provided to function : ''; utf8 is required."},
    {3146, "22032", "Invalid data type for JSON data in argument  to function ; a JSON string or JSON type is required."},
    {3147, "22032", "Cannot CAST value to JSON."},
    {3148, "42000", "A path expression must be encoded in the utf8 character set. The path expression '' is encoded in character set ''."},
    {3149, "42000", "In this situation, path expressions may not contain the * and ** tokens."},
    {3150, "22032", "The JSON value is too big to be stored in a JSON column."},
    {3151, "22032", "The JSON object contains a key name that is too long."},
    {3152, "42000", "JSON column '' cannot be used in key specification."},
    {3153, "42000", "The path expression '$' is not allowed in this context."},
    {3154, "42000", "The oneOrAll argument to  may take these values: 'one' or 'all'."},
    {3155, "22003", "Out of range JSON value for CAST to  from column  at row "},
    {3156, "22018", "Invalid JSON value for CAST to  from column  at row "},
    {3157, "22032", "The JSON document exceeds the maximum depth."},
    {3158, "22032", "JSON documents may not contain NULL member names."},
    {3159, "HY000", "Connections using insecure transport are prohibited while --require_secure_transport=ON."},
    {3160, "HY000", "No secure transports (SSL or Shared Memory) are configured, unable to set --require_secure_transport=ON."},
    {3161, "HY000", "Storage engine  is disabled (Table creation is disallowed)."},
    {3162, "HY000", "User  does not exist."},
    {3163, "HY000", "User  already exists."},
    {3164, "HY000", "Aborted by Audit API ('';)."},
    {3165, "42000", "A path expression is not a path to a cell in an array."},
    {3166, "HY000", "Another buffer pool resize is already in progress."},
    {3167, "HY000", "The '' feature is disabled; see the documentation for ''"},
    {3168, "HY000", "Server isn't available"},
    {3169, "HY000", "Session was killed"},
    {3170, "HY000", "Memory capacity of  bytes for '' exceeded. "},
    {3171, "HY000", "Range optimization was not done for this query."},
    {3172, "HY000", "Partitioning upgrade required. Please dump/reload to fix it or do: ALTER TABLE ``.`` UPGRADE PARTITIONING"},
    {3173, "HY000", "The client holds ownership of the GTID . Therefore, WAIT_FOR_EXECUTED_GTID_SET cannot wait for this GTID."},
    {3174, "HY000", "Cannot add foreign key on the base column of indexed virtual column."},
    {3175, "HY000", "Cannot create index on virtual column whose base column has foreign constraint."},
    {3176, "HY000", "Please do not modify the  table with an XA transaction. This is an internal system table used to store GTIDs for committed transactions. Although modifying it can lead to an inconsistent GTID state, if neccessary you can modify it with a non-XA transaction."},
    {3177, "HY000", "Lock acquisition refused by storage engine."},
    {3178, "HY000", "ADD COLUMN col...VIRTUAL, ADD INDEX(col)"},
    {3179, "HY000", "Master key rotation is not supported by storage engine."},
    {3180, "HY000", "Encryption key rotation error reported by SE: "},
    {3181, "HY000", "Write to binlog failed. However, master key rotation has been completed successfully."},
    {3182, "HY000", "Storage engine is not available."},
    {3183, "HY000", "This tablespace can't be encrypted."},
    {3184, "HY000", "Invalid encryption option."},
    {3185, "HY000", "Can't find master key from keyring, please check keyring plugin is loaded."},
    {3186, "HY000", "Parser bailed out for this query."},
    {3187, "HY000", "Cannot alter encryption attribute by inplace algorithm."},
    {3188, "HY000", "Function '' failed because underlying keyring service returned an error. Please check if a keyring plugin is installed and that provided arguments are valid for the keyring you are using."},
    {3189, "HY000", "It seems that your db schema is old. The  column is 77 characters long and should be 93 characters long. Please run mysql_upgrade."},
    {3190, "HY000", "RESET MASTER is not allowed because ."},
    {3191, "HY000", "The START GROUP_REPLICATION command failed since the group already has 9 members."},
    {3192, "HY000", "Cannot add foreign key on the base column of stored column."},
    {3193, "HY000", "Cannot complete the operation because table is referenced by another connection."},
    {3194, "HY000", "The partition engine, used by table '.', is deprecated and will be removed in a future release. Please use native partitioning instead."}
};

#endif
